﻿using UnityEngine;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;
using MVR.FileManagementSecure;
using System.Security.AccessControl;


namespace JayJayWon
{
    public class Settings
    {
        public static JSONStorableBool sceneImportPersistCacheJSB = new JSONStorableBool("sceneImportPersistCache", true, SettingsBoolChange);
        public static JSONStorableBool sceneImportDisableNewAtomJSB = new JSONStorableBool("sceneImportDisableNewAtom", false, SettingsBoolChange);
        public static JSONStorableBool sceneImportUseSceneThumbnailJSB = new JSONStorableBool("sceneImportUseSceneThumbnail", true, SettingsBoolChange);

        public static JSONStorableString restoreNameJSS = new JSONStorableString("restoreName", "");

        public static JSONStorableBool acceptSymLinksWarningJSB = new JSONStorableBool("acceptSymLinksWarning", false, SettingsBoolChange);
        public static JSONStorableBool acceptClothingTagsWarningJSB = new JSONStorableBool("acceptClothingTagsWarning", false, SettingsBoolChange);

        public static JSONStorableFloat maxButtonsPerPageVRJSF = new JSONStorableFloat("maxButtonsPerPageVR", 200f,MaxButtonsPerPageVRCallback, 20f,2000f);
        public static JSONStorableFloat maxButtonsPerPageDesktopJSF = new JSONStorableFloat("maxButtonsPerPageDesktop", 200f, MaxButtonsPerPageDesktopCallback, 20f, 2000f);

        public static float maxButtonsPerPage { get
            {
                if (Globals.isVREnabled) return maxButtonsPerPageVRJSF.val;
                else return maxButtonsPerPageDesktopJSF.val;
            } }

        public static JSONStorableBool duplicateTagDataOnSaveJSB = new JSONStorableBool("duplicateTagDataOnSave", true, SettingsBoolChange);

        public static JSONStorableBool selectNewResourceOnSaveJSB = new JSONStorableBool("selectNewResourceOnSave", true, SettingsBoolChange);

        public static JSONStorableBool selectAtomOnLoadJSB = new JSONStorableBool("selectAtomOnLoad", true,SettingsBoolChange);

        public static JSONStorableBool keepFolderBrowserOpenJSB = new JSONStorableBool("keepFolderBrowserOpen", false, SettingsBoolChange);

        public static JSONStorableBool suppressClothingLoadJSB = new JSONStorableBool("suppressClothingLoad", true, SettingsBoolChange);

        public static JSONStorableBool onlySuppressRealClothingJSB = new JSONStorableBool("onlySuppressRealClothing", true, SettingsBoolChange);

        public static JSONStorableBool onlyReplaceRealClothingJSB = new JSONStorableBool("onlyReplaceRealClothing", true, SettingsBoolChange);

        public static JSONStorableBool heelAdjustMocapJSB = new JSONStorableBool("heelAdjustMocap", true, SettingsBoolChange);

        public static JSONStorableBool openPluginUIJSB = new JSONStorableBool("openPluginUI", false, SettingsBoolChange);

        public static JSONStorableBool suppressScaleChangeJSB = new JSONStorableBool("suppressClothingLoad", false, SettingsBoolChange);

        public static JSONStorableBool morphPresetIncludePhysicalJSB = new JSONStorableBool("morphPresetIncludePhysical", false, SettingsBoolChange);
        public static JSONStorableBool morphPresetIncludeAppJSB = new JSONStorableBool("morphPresetIncludeApp", true, SettingsBoolChange);

        public static JSONStorableBool generalPresetIncludePhysicalJSB = new JSONStorableBool("generalPresetIncludePhysical", true, SettingsBoolChange);
        public static JSONStorableBool generalPresetIncludePoseJSB = new JSONStorableBool("generalPresetIncludePose", true, SettingsBoolChange);
        public static JSONStorableBool generalPresetIncludeAppJSB = new JSONStorableBool("generalPresetIncludeApp", true, SettingsBoolChange);
        public static JSONStorableBool generalPresetImportIncludeMocapJSB = new JSONStorableBool("generalPresetIncludeMocap", true, SettingsBoolChange);

        public static JSONStorableBool sideTagBoxEnabledJSB = new JSONStorableBool("tagBoxEnabled", true, SettingsBoolChange);

        public static JSONStorableFloat uiScaleJSF = new JSONStorableFloat("Desktop UI Scale", 1f, UIScaleCallback, 0.5f, 2f);
        public static JSONStorableEnumStringChooser resourceNameSearchModeJSESC = new JSONStorableEnumStringChooser("resourceNameSearchMode", ResourceNameSearchMode.enumManifestName,ResourceNameSearchMode.ContainsFullPath,"Resource Filter Name Search Mode", ResourceNameSearchModeCallback);
        public static JSONStorableEnumStringChooser launchButtonPlacementJSESC = new JSONStorableEnumStringChooser("launchButtonPlacement", VAMUILaunchButtonPosition.enumManifestName, VAMUILaunchButtonPosition.sceneBrowserSub, "BrowserAssist Launch Button Position on VAM UI", LaunchButtonPlacementCallback);

        public static JSONStorableEnumStringChooser defaultTargetPersonTypeJSE = new JSONStorableEnumStringChooser("defaultTargetPersonType",PersonGenderTypes.enumManifestName,PersonGenderTypes.firstFemale,"Default Target Person Type");

        private static int _resourceButtonSizeVR=4;
        private static int _resourceButtonSizeDesktop=4;
        public static int resourceButtonSizeVR { get{ return _resourceButtonSizeVR; } set { _resourceButtonSizeVR = value;SaveSettings(); } }
        public static int resourceButtonSizeDesktop { get { return _resourceButtonSizeDesktop; } set { _resourceButtonSizeDesktop = value; SaveSettings(); } }

        public static JSONStorableBool enableTopScreenLaunchButtonJSB = new JSONStorableBool("EnableTopScreenLaunchButton", true, EnableTopScreenLaunchButtonCallback);
        public static JSONStorableBool enableBulkDeleteJSB = new JSONStorableBool("EnableBulkDelete", false, SettingsBoolChange);
        public static JSONStorableBool enableCSLReferencedPluginsJSB = new JSONStorableBool("EnableCSLReferencedPlugins", false, SettingsBoolChange);
        public static JSONStorableBool enableQuickFiltersJSB = new JSONStorableBool("EnableQuickFilters", true, EnableQuickFiltersCallback);

        public static JSONStorableMultiEnumStringChooser defaultResourceTypeJMESC ;

        public static JSONStorableEnumStringChooser defaultCreatorFilterOrderJSEC = new JSONStorableEnumStringChooser("creatorFilterOrder",CreatorFilterSortOrder.enumManifestName,CreatorFilterSortOrder.resourceCount,"Default order for Creator Filter choices", SettingsStringChange);

        public static RelativeAtomPositionRotation desktopDefaultNewAtomPosRot = new RelativeAtomPositionRotation();
        public static RelativeAtomPositionRotation vrDefaultNewAtomPosRot = new RelativeAtomPositionRotation();

        public static JSONStorableBool dockToVAMUIJSB = new JSONStorableBool("DockToVAMUI", true, SettingsBoolChange);

        public static JSONStorableBool disableMetaPurgeOnMissingVARJSB = new JSONStorableBool("disableMetaPurgeOnMissingVAR", false, SettingsBoolChange);

        private static Dictionary<int, ResourceSettings> resourceSettings = new Dictionary<int, ResourceSettings>();

        private static Dictionary<string, ResourceSettings> atomPresetResourceSettings = new Dictionary<string, ResourceSettings>();


        private static HashSet<int> concealedResourceTypes = new HashSet<int>();
        private static HashSet<string> concealedAtomPresetResourceTypes = new HashSet<string>();

        public static ResourceSettings GetResourceSettings(int resourceType, string atomPresetResourceType)
        {
            if (resourceType == ResourceType.presetAtom)
            {

                if (!atomPresetResourceSettings.ContainsKey(atomPresetResourceType)) atomPresetResourceSettings.Add(atomPresetResourceType, new ResourceSettings(resourceType, atomPresetResourceType));
                return atomPresetResourceSettings[atomPresetResourceType];
            }
            else
            {
                if (!resourceSettings.ContainsKey(resourceType)) return null;
                return resourceSettings[resourceType];
            }
        }

        private static bool restoreInProgress = false;

        static Settings()
        {
            defaultCreatorFilterOrderJSEC.SetEnumChoices(CreatorFilterSortOrder.enumManifestName,new List<int> { CreatorFilterSortOrder.defaultVal });
        }
        public static int concealedResourceTypeCount { get
            {
                return concealedResourceTypes.Count;
            } }
        public static bool IsResourceConcealed(int resourceType, string atomPresetResourceType)
        {
            if (resourceType!=ResourceType.presetAtom && concealedResourceTypes.Contains(resourceType)) return true;

            if (resourceType == ResourceType.presetAtom && concealedAtomPresetResourceTypes.Contains(atomPresetResourceType)) return true;

            return false;
        }

        public static void SetConcealed(int resourceType, string atomPresetResourceType)
        {
            if (resourceType != ResourceType.presetAtom) concealedResourceTypes.Add(resourceType);
            else concealedAtomPresetResourceTypes.Add(atomPresetResourceType);
        }
        public static void UnsetConcealed(int resourceType, string atomPresetResourceType)
        {
            if (resourceType != ResourceType.presetAtom) concealedResourceTypes.Remove(resourceType);
            else concealedAtomPresetResourceTypes.Remove(atomPresetResourceType);
        }

        public static void RePopulateResourceTypeSelector()
        {
            ResourceManifest.PopulateResourceTypeSelector(defaultResourceTypeJMESC);
            if (!defaultResourceTypeJMESC.choices.Contains(defaultResourceTypeJMESC.val)) defaultResourceTypeJMESC.val = defaultResourceTypeJMESC.choices[0];
        }

        private static void EnableTopScreenLaunchButtonCallback(bool b)
        {
            SaveSettings();
            if (!restoreInProgress) Globals.mvrScript.ToggleTopMenuLanchButton();
        }

        private static void EnableQuickFiltersCallback(bool b)
        {
            SaveSettings();
            if (!restoreInProgress &&
                BrowserAssist.mainBrowserUI != null) BrowserAssist.mainBrowserUI.RefreshQuickFilterPanelVisibility();
        }


        private static void LaunchButtonPlacementCallback(string val)
        {
            SaveSettings();
            if (!restoreInProgress) Globals.mvrScript.RePositionLaunchButton();
        }
        private static void MaxButtonsPerPageVRCallback(float val)
        {
            maxButtonsPerPageVRJSF.valNoCallback = Mathf.Round(val / 10f) *10f;
            if (Globals.isVREnabled &&
                BrowserAssist.mainBrowserUI!=null && BrowserAssist.mainBrowserUI.resourceBrowserUI != null && BrowserAssist.mainBrowserUI.isVisible) BrowserAssist.mainBrowserUI.RefreshButtonLayout();
            if (Globals.isVREnabled &&
                BrowserAssist.callbackBrowserUI != null && BrowserAssist.callbackBrowserUI.resourceBrowserUI != null && BrowserAssist.callbackBrowserUI.isVisible) BrowserAssist.callbackBrowserUI.RefreshButtonLayout();
            SaveSettings();
        }

        private static void MaxButtonsPerPageDesktopCallback(float val)
        {
            maxButtonsPerPageDesktopJSF.valNoCallback = Mathf.Round(val / 10f) * 10f;
            if (!Globals.isVREnabled &&
                BrowserAssist.mainBrowserUI != null && BrowserAssist.mainBrowserUI.resourceBrowserUI != null && BrowserAssist.mainBrowserUI.isVisible) BrowserAssist.mainBrowserUI.RefreshButtonLayout();
            if (!Globals.isVREnabled &&
                BrowserAssist.callbackBrowserUI != null && BrowserAssist.callbackBrowserUI.resourceBrowserUI != null && BrowserAssist.callbackBrowserUI.isVisible) BrowserAssist.callbackBrowserUI.RefreshButtonLayout();
            SaveSettings();
        }

        private static void ResourceNameSearchModeCallback(string val)
        {
            if (BrowserAssist.mainBrowserUI != null) BrowserAssist.mainBrowserUI.browserFiltersUI.SetResourceNameFilterHelpText();
            if (BrowserAssist.callbackBrowserUI != null) BrowserAssist.callbackBrowserUI.browserFiltersUI.SetResourceNameFilterHelpText();
            SaveSettings();
        }
        private static void UIScaleCallback(float val)
        {
            if (BrowserAssist.mainBrowserUI != null) BrowserAssist.mainBrowserUI.RefreshDesktopScale();
            if (BrowserAssist.callbackBrowserUI != null) BrowserAssist.callbackBrowserUI.RefreshDesktopScale();
            SaveSettings();
        }

        public static void SettingsBoolChange(bool val)
        {
            SaveSettings();
        }

        private static void SettingsFloatChange(float val)
        {
            SaveSettings();
        }

        private static void SettingsStringChange(string val)
        {
            SaveSettings();
        }

        private static void SettingsIntChange(int val)
        {
            SaveSettings();
        }

        public static void SaveSettings()
        {
            if (!restoreInProgress)
            {
                JSONClass settingsJC = new JSONClass();

                settingsJC["BAMajorVersion"].AsInt = Const.BAMajorVersion;
                settingsJC["BAMinorVersion"].AsInt = Const.BAMinorVersion;
                settingsJC["BAFixVersion"].AsInt = Const.BAFixVersion;

                JSONArray SupportedResourceTypesJA = new JSONArray();
                foreach (string resourceType in ResourceType.currentSupportedResourceTypeNames)
                {
                    SupportedResourceTypesJA.Add(resourceType);
                }
                settingsJC["SupportedResourceTypes"] = SupportedResourceTypesJA;

                JSONArray ConcealedResourceTypesJA = new JSONArray();
                foreach (int resourceType in concealedResourceTypes)
                {
                    ConcealedResourceTypesJA.Add(EnumManifest.GetStoreVal(ResourceType.enumManifestName,resourceType));
                }
                settingsJC["ConcealedResourceTypes"] = ConcealedResourceTypesJA;

                JSONArray ConcealedAtomPresetResourceTypesJA = new JSONArray();
                foreach (string atomPresetResourceType in concealedAtomPresetResourceTypes)
                {
                    ConcealedAtomPresetResourceTypesJA.Add(atomPresetResourceType);
                }
                settingsJC["ConcealedAtomPresetResourceTypes"] = ConcealedAtomPresetResourceTypesJA;

                maxButtonsPerPageVRJSF.StoreJSON(settingsJC["VRSettings"].AsObject);
                maxButtonsPerPageDesktopJSF.StoreJSON(settingsJC["DesktopSettings"].AsObject);
                uiScaleJSF.StoreJSON(settingsJC["DesktopSettings"].AsObject);

                resourceNameSearchModeJSESC.StoreJSON(settingsJC["FilterSettings"].AsObject);
                defaultCreatorFilterOrderJSEC.StoreJSON(settingsJC["FilterSettings"].AsObject);
                launchButtonPlacementJSESC.StoreJSON(settingsJC["GeneralSettings"].AsObject);
                settingsJC["BrowserSettings"]["ResourceButtonSizeVR"].AsInt = _resourceButtonSizeVR;
                settingsJC["BrowserSettings"]["ResourceButtonSizeDesktop"].AsInt = _resourceButtonSizeDesktop;
                defaultResourceTypeJMESC.StoreJSON(settingsJC["BrowserSettings"].AsObject);
                enableTopScreenLaunchButtonJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);
                enableBulkDeleteJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);
                enableCSLReferencedPluginsJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);
                enableQuickFiltersJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);

                selectAtomOnLoadJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                duplicateTagDataOnSaveJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                selectNewResourceOnSaveJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                keepFolderBrowserOpenJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                onlySuppressRealClothingJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                suppressClothingLoadJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);

                openPluginUIJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                suppressScaleChangeJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                morphPresetIncludePhysicalJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                morphPresetIncludeAppJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetIncludePhysicalJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetIncludePoseJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetIncludeAppJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetImportIncludeMocapJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject) ;

                onlyReplaceRealClothingJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                heelAdjustMocapJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);
                sideTagBoxEnabledJSB.StoreJSON(settingsJC["ResourceActionSettings"].AsObject);

                acceptSymLinksWarningJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);
                acceptClothingTagsWarningJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);

                restoreNameJSS.StoreJSON(settingsJC);

                desktopDefaultNewAtomPosRot.StoreJSON(settingsJC["DesktopSettings"]["DefaultNewAtomPosRot"].AsObject);
                vrDefaultNewAtomPosRot.StoreJSON(settingsJC["VRSettings"]["DefaultNewAtomPosRot"].AsObject);

                dockToVAMUIJSB.StoreJSON(settingsJC["VRSettings"].AsObject);
                disableMetaPurgeOnMissingVARJSB.StoreJSON(settingsJC["GeneralSettings"].AsObject);

                sceneImportPersistCacheJSB.StoreJSON(settingsJC["SceneImportSettings"].AsObject);
                sceneImportDisableNewAtomJSB.StoreJSON(settingsJC["SceneImportSettings"].AsObject);
                sceneImportUseSceneThumbnailJSB.StoreJSON(settingsJC["SceneImportSettings"].AsObject);

                foreach (int resourceType in EnumManifest.GetEnumsList(ResourceType.enumManifestName))
                {
                    if (resourceType != ResourceType.presetAtom)
                    {
                        string resourceTypeStoreLabel = EnumManifest.GetStoreVal(ResourceType.enumManifestName, resourceType);

                        settingsJC["ResourceSettings"][resourceTypeStoreLabel] = resourceSettings[resourceType].GetJSON();
                    }
                    
                }
                foreach (var resourceSettingsKVP in atomPresetResourceSettings)
                {
                    string resourceTypeStoreLabel = EnumManifest.GetStoreVal(ResourceType.enumManifestName, ResourceType.presetAtom);
                    settingsJC["ResourceSettings"][resourceTypeStoreLabel][resourceSettingsKVP.Key] = resourceSettingsKVP.Value.GetJSON();

                }

                settingsJC["creatorSettings"] = CreatorManifest.GetJSON();
                settingsJC["QuickFilterSettings"] = QuickFilterSettings.GetJSONClass();

                SuperController.singleton.SaveJSON(settingsJC, Const.BAScriptDataFolder + "\\" + "BASettings.cfg");
            }

        }

        public static JSONClass GetSettingsJSON()
        {
            JSONClass settingsJSON = null;

            if (FileManagerSecure.FileExists(Const.BAScriptDataFolder + "\\" + "BASettings.cfg"))
            {

                JSONClass settingsJC;
                try
                {
                    settingsJC = SuperController.singleton.LoadJSON(Const.BAScriptDataFolder + "\\" + "BASettings.cfg").AsObject;
                    return settingsJC;
                }
                catch
                {
                    Utils.LogDebug("Settings.LoadSettings: Error during load of settings config file. Possible malformed JSON");
                    return null;
                }
            }

            return settingsJSON;
        }

        public static void EarlyLoadSettings(JSONClass settingsJC)
        {
            if (settingsJC != null)
            {
                restoreInProgress = true;
                disableMetaPurgeOnMissingVARJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);
                restoreNameJSS.RestoreFromJSON(settingsJC);


                restoreInProgress = false;
            }
            defaultResourceTypeJMESC = new JSONStorableMultiEnumStringChooser("defaultResourceTypeMulti", null, null, topEnumManifestName: ResourceType.enumManifestName, topEnumCallbackFunction: SettingsIntChange, mainValCallbackFunction: SettingsStringChange);

        }

        public static HashSet<int> GetLastSupportedResourceTypes(JSONClass settingsJC)
        {
            HashSet<int> resourceTypes = new HashSet<int>() ;
            if (settingsJC != null)
            {
                restoreInProgress = true;
                if (settingsJC["SupportedResourceTypes"] != null)
                {
                    resourceTypes = new HashSet<int>();
                    foreach (JSONNode jn in settingsJC["SupportedResourceTypes"].AsArray)
                    {
                        resourceTypes.Add(EnumManifest.GetEnumValFromStoreVal(ResourceType.enumManifestName, jn));
                    }
                }
                else resourceTypes = ResourceType.originalSupportedResourceTypes;

                restoreInProgress = false;
            }
            return resourceTypes;
        }

        public static JSONStorableEnumStringChooser GetCurrentCreatorFilterOrder(int resourceType, string atomPresetResourceType)
        {
            var resourceSettings = GetResourceSettings(resourceType, atomPresetResourceType);

            if (resourceSettings == null) return new JSONStorableEnumStringChooser("dummyCreatorFilterOrderJSEnum",CreatorFilterSortOrder.enumManifestName,CreatorFilterSortOrder.alphabetically,"");

            if (resourceSettings.creatorFilterOrderJSEC.val == CreatorFilterSortOrder.defaultVal) return defaultCreatorFilterOrderJSEC;
            else return resourceSettings.creatorFilterOrderJSEC;
        }

        public static void LoadSettings(JSONClass settingsJC)
        {
            List<int> resourceTypesToExclude = new List<int>();
            if (!PC.patreonContentEnabled)
            {
                resourceTypesToExclude = EnumManifest.GetEnumsList(ResourceType.enumManifestName);
                resourceTypesToExclude.Remove(ResourceType.scene);
                resourceTypesToExclude.Remove(ResourceType.presetAppearance);
            }
            desktopDefaultNewAtomPosRot.Init(SettingsIntChange, SettingsIntChange, SettingsStringChange);
            desktopDefaultNewAtomPosRot.InitSettingsCallback(SettingsFloatChange, SettingsIntChange);
            vrDefaultNewAtomPosRot.Init(SettingsIntChange, SettingsIntChange, SettingsStringChange);
            vrDefaultNewAtomPosRot.InitSettingsCallback(SettingsFloatChange, SettingsIntChange);  
            
            defaultResourceTypeJMESC.label = "Initial Resource Type on BrowserAssist startup";

            if (settingsJC!=null)
            {
                restoreInProgress = true;
                defaultResourceTypeJMESC.valTopEnum = ResourceType.scene;
                foreach (int resourceType in EnumManifest.GetEnumsList(ResourceType.enumManifestName))
                {
                    string resourceTypeStoreLabel = EnumManifest.GetStoreVal(ResourceType.enumManifestName, resourceType);

                    if (resourceType != ResourceType.presetAtom)
                    {
                        ResourceSettings newResourceSettings = new ResourceSettings(resourceType, "");
                        if (settingsJC["ResourceSettings"][resourceTypeStoreLabel] != null) newResourceSettings.RestoreJSON(settingsJC["ResourceSettings"][resourceTypeStoreLabel].AsObject);

                       resourceSettings.Add(resourceType, newResourceSettings);
                    }
                    else
                    {
                        var presetAtomResourceSettingsJC = settingsJC["ResourceSettings"][resourceTypeStoreLabel];

                        foreach (string presetAtomResourceType in Globals.nonPersonAtomTypes)
                        {
                            ResourceSettings newResourceSettings = new ResourceSettings(resourceType, presetAtomResourceType);
                            
                            if (presetAtomResourceSettingsJC!=null && presetAtomResourceSettingsJC[presetAtomResourceType] != null) newResourceSettings.RestoreJSON(presetAtomResourceSettingsJC[presetAtomResourceType].AsObject);

                            if (atomPresetResourceSettings.ContainsKey(presetAtomResourceType))
                                atomPresetResourceSettings[presetAtomResourceType] = newResourceSettings;
                            else atomPresetResourceSettings.Add(presetAtomResourceType, newResourceSettings);
                        }
                    }
                        
                }
                concealedResourceTypes.Clear();
                if (settingsJC["ConcealedResourceTypes"] != null)
                {
                    foreach(JSONNode concealedResourceType in settingsJC["ConcealedResourceTypes"].AsArray)
                    {
                        concealedResourceTypes.Add(EnumManifest.GetEnumValFromStoreVal(ResourceType.enumManifestName,concealedResourceType));
                    }
                }

                concealedAtomPresetResourceTypes.Clear();
                if (settingsJC["ConcealedAtomPresetResourceTypes"] != null)
                {
                    foreach (JSONNode atomPresetResourceType in settingsJC["ConcealedAtomPresetResourceTypes"].AsArray)
                    {
                        concealedAtomPresetResourceTypes.Add(atomPresetResourceType);
                    }
                }
                RePopulateResourceTypeSelector();

                if (settingsJC["SceneImportSettings"]!=null)
                {
                    sceneImportPersistCacheJSB.RestoreFromJSON(settingsJC["SceneImportSettings"].AsObject);
                    sceneImportDisableNewAtomJSB.RestoreFromJSON(settingsJC["SceneImportSettings"].AsObject);
                    sceneImportUseSceneThumbnailJSB.RestoreFromJSON(settingsJC["SceneImportSettings"].AsObject);
                }

                uiScaleJSF.RestoreFromJSON(settingsJC["DesktopSettings"].AsObject);
                maxButtonsPerPageVRJSF.RestoreFromJSON(settingsJC["VRSettings"].AsObject);
                maxButtonsPerPageDesktopJSF.RestoreFromJSON(settingsJC["DesktopSettings"].AsObject);

                if (settingsJC["BrowserSettings"]["Maximum Number of Resources per Browser page"] != null)
                {
                    maxButtonsPerPageVRJSF.valNoCallback = settingsJC["BrowserSettings"]["Maximum Number of Resources per Browser page"].AsFloat;
                    maxButtonsPerPageDesktopJSF.valNoCallback = settingsJC["BrowserSettings"]["Maximum Number of Resources per Browser page"].AsFloat;
                }

                resourceNameSearchModeJSESC.RestoreFromJSON(settingsJC["FilterSettings"].AsObject);
                defaultCreatorFilterOrderJSEC.RestoreFromJSON(settingsJC["FilterSettings"].AsObject);

                launchButtonPlacementJSESC.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);
                if (settingsJC["BrowserSettings"]["ResourceButtonSizeVR"]!=null) _resourceButtonSizeVR = settingsJC["BrowserSettings"]["ResourceButtonSizeVR"].AsInt;
                if (settingsJC["BrowserSettings"]["ResourceButtonSizeDesktop"] != null) _resourceButtonSizeDesktop = settingsJC["BrowserSettings"]["ResourceButtonSizeDesktop"].AsInt;
                selectAtomOnLoadJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                duplicateTagDataOnSaveJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                selectNewResourceOnSaveJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                keepFolderBrowserOpenJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                onlySuppressRealClothingJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                suppressClothingLoadJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                onlyReplaceRealClothingJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                heelAdjustMocapJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                openPluginUIJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                suppressScaleChangeJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                morphPresetIncludePhysicalJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                morphPresetIncludeAppJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetIncludePhysicalJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetIncludePoseJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetIncludeAppJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);
                generalPresetImportIncludeMocapJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);

                sideTagBoxEnabledJSB.RestoreFromJSON(settingsJC["ResourceActionSettings"].AsObject);

                acceptSymLinksWarningJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);
                acceptClothingTagsWarningJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);

                if (settingsJC["BrowserSettings"]["defaultResourceType"] != null) defaultResourceTypeJMESC.valTopEnum = EnumManifest.GetEnumValFromStoreVal(ResourceType.enumManifestName, settingsJC["BrowserSettings"]["defaultResourceType"]);
                else defaultResourceTypeJMESC.RestoreFromJSON(settingsJC["BrowserSettings"].AsObject);

                enableTopScreenLaunchButtonJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);
                enableBulkDeleteJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);
                enableCSLReferencedPluginsJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);
                enableQuickFiltersJSB.RestoreFromJSON(settingsJC["GeneralSettings"].AsObject);

                if (settingsJC["DesktopSettings"]["DefaultNewAtomPosRot"]!=null)desktopDefaultNewAtomPosRot.RestoreFromJSON(settingsJC["DesktopSettings"]["DefaultNewAtomPosRot"].AsObject);
                if (settingsJC["VRSettings"]["DefaultNewAtomPosRot"] != null) vrDefaultNewAtomPosRot.RestoreFromJSON(settingsJC["VRSettings"]["DefaultNewAtomPosRot"].AsObject);

                dockToVAMUIJSB.RestoreFromJSON(settingsJC["VRSettings"].AsObject);

                if (settingsJC["creatorSettings"] != null) CreatorManifest.RestoreJSON(settingsJC["creatorSettings"].AsArray);
                if (settingsJC["QuickFilterSettings"] != null) QuickFilterSettings.RestoreJSONClass(settingsJC["QuickFilterSettings"].AsObject);

                restoreInProgress = false;
            }
            else
            {
                foreach (int resourceType in EnumManifest.GetEnumsList(ResourceType.enumManifestName))
                {
                    if (resourceType != ResourceType.presetAtom)
                    {
                        ResourceSettings newResourceSettings = new ResourceSettings(resourceType,"");
                        resourceSettings.Add(resourceType, newResourceSettings);
                    }
                    else
                    {
                        foreach (string presetAtomResourceType in Globals.nonPersonAtomTypes)
                        {
                            ResourceSettings newResourceSettings = new ResourceSettings(resourceType, presetAtomResourceType);
                            atomPresetResourceSettings.Add(presetAtomResourceType, newResourceSettings);
                        }
                    }
                    
                }
                SaveSettings();
            }

        }
    }

    public class ResourceSettings
    {
        public JSONStorableBool closeBrowserUIonResourceLoadJSB = new JSONStorableBool("closeBrowserUIonResourceLoad", false, SettingsBoolChange);
        public JSONStorableBool mergeLoadJSB = new JSONStorableBool("mergeLoad", false, SettingsBoolChange);

        public JSONStorableEnumStringChooser creatorFilterOrderJSEC = new JSONStorableEnumStringChooser("creatorFilterOrder", CreatorFilterSortOrder.enumManifestName, CreatorFilterSortOrder.defaultVal, "Order for Creator Filter choices", SettingsStringChange);

        public ResourceBrowserFilterSettings defaultFilterSettings;

        private int resourceType;
        private string atomPresetResourceType;
        public ResourceSettings(int resourceType, string atomPresetResourceType)
        {
            defaultFilterSettings = new ResourceBrowserFilterSettings(resourceType,atomPresetResourceType);
            this.resourceType = resourceType;
            this.atomPresetResourceType = atomPresetResourceType;
        }

        public virtual JSONClass GetJSON()
        {
            JSONClass resourceSettingsJC = new JSONClass();
            closeBrowserUIonResourceLoadJSB.StoreJSON(resourceSettingsJC);
            mergeLoadJSB.StoreJSON(resourceSettingsJC);
            creatorFilterOrderJSEC.StoreJSON(resourceSettingsJC);
            resourceSettingsJC["defaultFilterSettings"] = defaultFilterSettings.GetJSON();
            resourceSettingsJC["combiTags"] = TagManifest.GetCombiTagsJSON(resourceType, atomPresetResourceType);
            resourceSettingsJC["hiddenTags"] = TagManifest.GetHiddenTagsJSON(resourceType, atomPresetResourceType);
            resourceSettingsJC["preferredTags"] = TagManifest.GetPreferredTagsJSON(resourceType, atomPresetResourceType);


            return resourceSettingsJC;
        }

        public virtual void RestoreJSON(JSONClass resourceSettingsJC)
        {
            closeBrowserUIonResourceLoadJSB.RestoreFromJSON(resourceSettingsJC);
            mergeLoadJSB.RestoreFromJSON(resourceSettingsJC);
            creatorFilterOrderJSEC.RestoreFromJSON(resourceSettingsJC);
            defaultFilterSettings.RestoreJSON(resourceSettingsJC["defaultFilterSettings"].AsObject);

            if (resourceSettingsJC["hiddenTags"] != null) TagManifest.RestoreHiddenTagsJSON(resourceType, atomPresetResourceType, resourceSettingsJC["hiddenTags"].AsArray);

            if (resourceSettingsJC["preferredTags"] != null) TagManifest.RestorePreferredTagsJSON(resourceType, atomPresetResourceType, resourceSettingsJC["preferredTags"].AsArray);

            if (resourceSettingsJC["combiTags"] != null) TagManifest.RestoreCombiTagsJSON(resourceType, atomPresetResourceType, resourceSettingsJC["combiTags"].AsArray);
        }

        private static void SettingsBoolChange(bool val)
        {
            Settings.SaveSettings();
        }

        private static void SettingsStringChange(string val)
        {
            Settings.SaveSettings();
        }
    }

    public class ResourceBrowserFilterSettings
    {
        public JSONStorableMultiEnumStringChooser creatorJSMultiEnum;
        public JSONStorableMultiEnumStringChooser clothingCreatorJSME;
        public JSONStorableString folderFilterJSS;
        public JSONStorableBool inludeSubFoldersJSB;
        public JSONStorableString resourceNameFilterJSS;

        public JSONStorableBool showHiddenJSB;
        public JSONStorableBool onlyFavouritesJSB;
        public JSONStorableBool onlyNewJSB;

        public JSONStorableMultiEnumStringChooser tagsFilterJSMultiEnum;
        public JSONStorableEnumStringChooser licenseFilterJSEnum;

        public JSONStorableEnumStringChooser selectModeJSEnum { get; set; }
        public JSONStorableEnumStringChooser sortModeJSEnum;

        public string resourceNameFilterQuick;

        public Folder selectedFolderFilter = null;

        public int resourceType { get; private set; }
        public int resourceCategory { get
            {
                return ResourceType.GetResourceCategory(resourceType);
            } }
        public string atomPresetResourceType { get; private set; }

        public bool combiTagFilterEnabled { get; set; } = false;
        public CombiTag combiTag;

        public void CopyFrom(ResourceBrowserFilterSettings source)
        {
            resourceType = source.resourceType;
            atomPresetResourceType= source.atomPresetResourceType;
            creatorJSMultiEnum.val = source.creatorJSMultiEnum.val;
            clothingCreatorJSME.val = source.clothingCreatorJSME.val;
            folderFilterJSS.val = source.folderFilterJSS.val;
            selectedFolderFilter= source.selectedFolderFilter;
            inludeSubFoldersJSB.val = source.inludeSubFoldersJSB.val;
            resourceNameFilterJSS.val = source.resourceNameFilterJSS.val;
            showHiddenJSB.val = source.showHiddenJSB.val;
            onlyFavouritesJSB.val = source.onlyFavouritesJSB.val;
            onlyNewJSB.val = source.onlyNewJSB.val;
            tagsFilterJSMultiEnum.val = source.tagsFilterJSMultiEnum.val;
            licenseFilterJSEnum.val = source.licenseFilterJSEnum.val;
            selectModeJSEnum.val = source.selectModeJSEnum.val;
            sortModeJSEnum.val = source.sortModeJSEnum.val;
            resourceNameFilterQuick = source.resourceNameFilterQuick;

            combiTagFilterEnabled = source.combiTagFilterEnabled;
            if (source.combiTagFilterEnabled) combiTag = new CombiTag(source.combiTag);
            else combiTag = new CombiTag("filterCombiTag", resourceType, atomPresetResourceType); ;
        }

        public ResourceBrowserFilterSettings(int _resourceType, string _atomPresetResourceType)
        {
            resourceType = _resourceType;
            atomPresetResourceType = _atomPresetResourceType;

            combiTag = new CombiTag("filterCombiTag", resourceType, atomPresetResourceType);

            var tagNames = TagManifest.GetTagNames(resourceType, atomPresetResourceType);
            tagsFilterJSMultiEnum = new JSONStorableMultiEnumStringChooser("tagsFilter", tagNames, tagNames, null, null, SettingsTagMainValChange, TagGroups.enumManifestName, SettingsTagTopValChange);

            showHiddenJSB = new JSONStorableBool("showHidden", false, SettingsBoolChange);
            onlyFavouritesJSB = new JSONStorableBool("onlyFavourites", false, SettingsBoolChange);
            onlyNewJSB = new JSONStorableBool("onlyNew", false, SettingsBoolChange);

            List<string> creators = CreatorManifest.GetAllCreatorNames();
            creatorJSMultiEnum = new JSONStorableMultiEnumStringChooser("creatorFilter", creators, creators, null, null, SettingsCreatorMainValChange, CreatorFilterChoices.enumManifestName, SettingsCreatorTopValChange);
            creatorJSMultiEnum.valTopEnumNoCallback = CreatorFilterChoices.all;

            List<string> clothingCreators = CreatorManifest.GetAllClothingCreatorNamesList();
            string initialClothingCreator = "";
            if (clothingCreators.Count > 0) initialClothingCreator= clothingCreators[0];
            clothingCreatorJSME = new JSONStorableMultiEnumStringChooser("clothingCreatorFilter", clothingCreators, clothingCreators,null,null, SettingsClothingCreatorMainValChange, ClothingCreatorFilterChoices.enumManifestName, SettingsClothingCreatorTopValChange);
            clothingCreatorJSME.valTopEnumNoCallback = ClothingCreatorFilterChoices.all;

            folderFilterJSS = new JSONStorableString("folderFilter", Const.GetResourceRootFolderNames(resourceType, atomPresetResourceType).First(),FolderFilterChange);
            selectedFolderFilter = FolderBrowser.GetFolder(folderFilterJSS.val, resourceType, atomPresetResourceType, true);

            inludeSubFoldersJSB = new JSONStorableBool("includeSubFolders",false, SettingsBoolChange);

            resourceNameFilterJSS = new JSONStorableString("resourceNameFilter", "");
            resourceNameFilterQuick = "";

            licenseFilterJSEnum = new JSONStorableEnumStringChooser("licenseFilter", LicenseType.enumManifestName, LicenseType.Any, "Package License", SettingsIntChange);

            selectModeJSEnum = new JSONStorableEnumStringChooser("selectMode", BrowserSelectMode.enumManifestName, BrowserSelectMode.single, "Select Mode", SettingsIntChange);
            sortModeJSEnum = new JSONStorableEnumStringChooser("sortMode", BrowserSortMode.enumManifestName, BrowserSortMode.newDateTime, "Order by", SettingsIntChange);
            
        }

        public ResourceBrowserFilterSettings(BAOrderedResourceFilter filters, CallbackBrowserFiltersUI parentFiltersUI=null)
        {
            resourceType = filters.resourceType;
            atomPresetResourceType= filters.atomPresetResourceType;

            combiTag = new CombiTag("filterCombiTag", resourceType, atomPresetResourceType);

            var settings = Settings.GetResourceSettings(resourceType,atomPresetResourceType);

            var tagNames = TagManifest.GetTagNames(resourceType, atomPresetResourceType);

            if (parentFiltersUI != null) tagsFilterJSMultiEnum = new JSONStorableMultiEnumStringChooser("tagsFilter", tagNames, tagNames, null, null, parentFiltersUI.TagMainValCallback, TagGroups.enumManifestName, parentFiltersUI.TagTopValCallback);
            else tagsFilterJSMultiEnum = new JSONStorableMultiEnumStringChooser("tagsFilter", tagNames, tagNames, null, null, null, TagGroups.enumManifestName, null);
            tagsFilterJSMultiEnum.label = "Tags";
            if (filters.tagGroupType == BATagGroupTypeEnum.hiddenOnly) tagsFilterJSMultiEnum.valTopEnumNoCallback = TagGroups.hiddenOnly;
            else if (filters.tagGroupType == BATagGroupTypeEnum.noTags) tagsFilterJSMultiEnum.valTopEnumNoCallback = TagGroups.noTags;
            else if (filters.tagGroupType == BATagGroupTypeEnum.anyTags) tagsFilterJSMultiEnum.valTopEnumNoCallback = TagGroups.anyTags;
            else if (filters.tagGroupType == BATagGroupTypeEnum.noUserTags) tagsFilterJSMultiEnum.valTopEnumNoCallback = TagGroups.noUserTags;
            else if (filters.tagGroupType == BATagGroupTypeEnum.wornClothingOnly) tagsFilterJSMultiEnum.valTopEnumNoCallback = TagGroups.wornClothingOnly;
            else if (filters.tagGroupType == BATagGroupTypeEnum.userDefault) tagsFilterJSMultiEnum.valNoCallback = settings.defaultFilterSettings.tagsFilterJSMultiEnum.val;
            else if (filters.tagGroupType == BATagGroupTypeEnum.userTag) tagsFilterJSMultiEnum.mainValNoCallback = filters.userTagName;


            if (parentFiltersUI != null) showHiddenJSB = new JSONStorableBool("showHidden", false, parentFiltersUI.ShowHiddenFilterCallback);
            else showHiddenJSB = new JSONStorableBool("showHidden", false);
            if (filters.showHidden == BAShowHiddenEnum.includeHidden) showHiddenJSB.valNoCallback = true;
            else if (filters.showHidden == BAShowHiddenEnum.userDefault) showHiddenJSB.valNoCallback = settings.defaultFilterSettings.showHiddenJSB.val;

            if (parentFiltersUI != null) onlyFavouritesJSB = new JSONStorableBool("onlyFavourites", false, parentFiltersUI.OnlyFavFilterCallback);
            else onlyFavouritesJSB = new JSONStorableBool("onlyFavourites", false);
            if (filters.onlyFav == BAOnlyFavoriteEnum.onlyFavorites) onlyFavouritesJSB.valNoCallback = true;
            else if (filters.onlyFav == BAOnlyFavoriteEnum.userDefault) onlyFavouritesJSB.valNoCallback = settings.defaultFilterSettings.onlyFavouritesJSB.val;

            if (parentFiltersUI != null) onlyNewJSB = new JSONStorableBool("onlyNew", false, parentFiltersUI.OnlyNewFilterCallback);
            else onlyNewJSB = new JSONStorableBool("onlyNew", false);    
            if (filters.onlyNew == BAOnlyNewEnum.onlyNew) onlyNewJSB.valNoCallback = true;
            else if (filters.onlyNew == BAOnlyNewEnum.userDefault) onlyNewJSB.valNoCallback = settings.defaultFilterSettings.onlyNewJSB.val;

            List<string> creators = CreatorManifest.GetAllCreatorNames();
            List<string> clothingCreators = CreatorManifest.GetAllClothingCreatorNamesList();
            string initialClothingCreator = "";
            if (clothingCreators.Count > 0) initialClothingCreator = clothingCreators[0];

            if (parentFiltersUI != null)
            {
                creatorJSMultiEnum = new JSONStorableMultiEnumStringChooser("creatorFilter", creators, creators, null, null, parentFiltersUI.CreatorsMainValCallback, CreatorFilterChoices.enumManifestName, parentFiltersUI.CreatorsTopValCallback);
                clothingCreatorJSME = new JSONStorableMultiEnumStringChooser("clothingCreatorFilter", clothingCreators, clothingCreators, null, null, parentFiltersUI.ClothingCreatorMainValCallback, ClothingCreatorFilterChoices.enumManifestName, parentFiltersUI.ClothingCreatorTopValCallback);
   
            }
            else
            {
                creatorJSMultiEnum = new JSONStorableMultiEnumStringChooser("creatorFilter", creators, creators, null, null, null, CreatorFilterChoices.enumManifestName, null);
                clothingCreatorJSME = new JSONStorableMultiEnumStringChooser("clothingCreatorFilter", clothingCreators, clothingCreators, null, null, null, ClothingCreatorFilterChoices.enumManifestName, null);
            }
            creatorJSMultiEnum.label = "Creator / Local";
            clothingCreatorJSME.label = "Clothes Creator";
            var localRootFolders = Const.GetResourceRootFolderNames(resourceType, atomPresetResourceType);
            folderFilterJSS = new JSONStorableString("folderFilter", localRootFolders.First(), FolderFilterChangeNoSave);
            if (parentFiltersUI != null) inludeSubFoldersJSB = new JSONStorableBool("includeSubFolders", false, parentFiltersUI.SubFoldersCallback);
            else inludeSubFoldersJSB = new JSONStorableBool("includeSubFolders", false);

            if (filters.creatorType == BACreatorTypeEnum.localFolders)
            {
                creatorJSMultiEnum.valTopEnumNoCallback = CreatorFilterChoices.localOnly;
                if (filters.localFolder != "") folderFilterJSS.valNoCallback = filters.localFolder;
                inludeSubFoldersJSB.valNoCallback = filters.includeSubFolders;
            }
            else if (filters.creatorType == BACreatorTypeEnum.allPackageCreators) creatorJSMultiEnum.valTopEnumNoCallback = CreatorFilterChoices.allVARs;
            else if (filters.creatorType == BACreatorTypeEnum.allLocalAndCreators) creatorJSMultiEnum.valTopEnumNoCallback = CreatorFilterChoices.all;
            else if (filters.creatorType == BACreatorTypeEnum.specificCreator) creatorJSMultiEnum.mainValNoCallback = filters.creatorName;
            else if (filters.creatorType == BACreatorTypeEnum.userDefault)
            {
                creatorJSMultiEnum.valNoCallback = settings.defaultFilterSettings.creatorJSMultiEnum.val;
                if (creatorJSMultiEnum.valType == JSONStorableMultiEnumStringChooser.topEnumValFlag && creatorJSMultiEnum.valTopEnum == CreatorFilterChoices.localOnly)
                {
                    folderFilterJSS.valNoCallback = settings.defaultFilterSettings.folderFilterJSS.val;
                    inludeSubFoldersJSB.valNoCallback = settings.defaultFilterSettings.inludeSubFoldersJSB.val;
                }
            }
            
            selectedFolderFilter = FolderBrowser.GetFolder(folderFilterJSS.val, resourceType, atomPresetResourceType,true);            

            resourceNameFilterJSS = new JSONStorableString("resourceNameFilter", filters.resourceName);
            resourceNameFilterQuick = resourceNameFilterJSS.val.ToLower();

            if (parentFiltersUI != null) licenseFilterJSEnum = new JSONStorableEnumStringChooser("licenseFilter", LicenseType.enumManifestName, LicenseType.Any, "Package License", parentFiltersUI.LicenseCallback);
            else licenseFilterJSEnum = new JSONStorableEnumStringChooser("licenseFilter", LicenseType.enumManifestName, LicenseType.Any, "Package License", null);
            if (filters.varLicenseType == BALicenseTypeEnum.userDefault) licenseFilterJSEnum.valNoCallback = settings.defaultFilterSettings.licenseFilterJSEnum.val;
            else licenseFilterJSEnum.valNoCallback = filters.varLicenseType;

            if (parentFiltersUI != null) selectModeJSEnum = new JSONStorableEnumStringChooser("selectMode", BrowserSelectMode.enumManifestName, BrowserSelectMode.instant, "Select Mode", parentFiltersUI.SelectModeCallback);
            else selectModeJSEnum = new JSONStorableEnumStringChooser("selectMode", BrowserSelectMode.enumManifestName, BrowserSelectMode.instant, "Select Mode", null);

            if (parentFiltersUI != null) sortModeJSEnum = new JSONStorableEnumStringChooser("sortMode", BrowserSortMode.enumManifestName, BrowserSortMode.newDateTime, "Order by", parentFiltersUI.SortByCallback );
            else sortModeJSEnum = new JSONStorableEnumStringChooser("sortMode", BrowserSortMode.enumManifestName, BrowserSortMode.newDateTime, "Order by");
            if (filters.resourceOrder == BAResultsSortModeEnum.userDefault) sortModeJSEnum.valNoCallback = settings.defaultFilterSettings.sortModeJSEnum.val;
            else sortModeJSEnum.valNoCallback = filters.resourceOrder;

        }

        public ResourceBrowserFilterSettings(BrowserFiltersUI parentFiltersUI, int _resourceType, string _atomPresetResourceType)
        {           
            resourceType = _resourceType;
            atomPresetResourceType = _atomPresetResourceType;

            var settings = Settings.GetResourceSettings(resourceType, atomPresetResourceType);
            combiTag = new CombiTag("filterCombiTag", resourceType, atomPresetResourceType);

            if (resourceCategory == ResourceCategory.clothing)
            {
                combiTag.AddCombiLogicCondition();
                combiTag.AddCombiLogicCondition();
                int position = 1;
                foreach (var clc in combiTag.combiLogicConditions)
                {
                    if (position== 1) clc.logicConditionJSEnum.val = CombiLogicConditionOptions.taggedWithAnyBodyRegion;
                    if (position == 2) clc.logicConditionJSEnum.val = CombiLogicConditionOptions.taggedWithAnyClothingType;
                    if (position == 3) clc.logicConditionJSEnum.val = CombiLogicConditionOptions.taggedWithAnyUserTag;
                    position++;
                }

            }

            var tagNames = TagManifest.GetTagNames(resourceType, atomPresetResourceType);
            tagsFilterJSMultiEnum = new JSONStorableMultiEnumStringChooser("tagsFilter", tagNames, tagNames, null, null, parentFiltersUI.TagMainValCallback, TagGroups.enumManifestName, parentFiltersUI.TagTopValCallback);
            tagsFilterJSMultiEnum.valNoCallback = settings.defaultFilterSettings.tagsFilterJSMultiEnum.val;
            tagsFilterJSMultiEnum.label = "Tags";          

            showHiddenJSB = new JSONStorableBool("showHidden", settings.defaultFilterSettings.showHiddenJSB.val, parentFiltersUI.ShowHiddenFilterCallback);
            onlyFavouritesJSB = new JSONStorableBool("onlyFavourites", settings.defaultFilterSettings.onlyFavouritesJSB.val, parentFiltersUI.OnlyFavFilterCallback);
            onlyNewJSB = new JSONStorableBool("onlyNew", settings.defaultFilterSettings.onlyNewJSB.val, parentFiltersUI.OnlyNewFilterCallback);

            List<string> creators = CreatorManifest.GetAllCreatorNames();
            creatorJSMultiEnum = new JSONStorableMultiEnumStringChooser("creatorFilter", creators, creators, null, null, parentFiltersUI.CreatorsMainValCallback, CreatorFilterChoices.enumManifestName, parentFiltersUI.CreatorsTopValCallback);
            creatorJSMultiEnum.valNoCallback = settings.defaultFilterSettings.creatorJSMultiEnum.val;
            creatorJSMultiEnum.label = "Creator / Local";

            List<string> clothingCreators = CreatorManifest.GetAllClothingCreatorNamesList();
            string initialClothingCreator = "";
            if (clothingCreators.Count > 0) initialClothingCreator = clothingCreators[0];
            clothingCreatorJSME = new JSONStorableMultiEnumStringChooser("clothingCreatorFilter", clothingCreators, clothingCreators, null, null, parentFiltersUI.ClothingCreatorMainValCallback, ClothingCreatorFilterChoices.enumManifestName, parentFiltersUI.ClothingCreatorTopValCallback);
            clothingCreatorJSME.label = "Clothes Creator";

            selectedFolderFilter = settings.defaultFilterSettings.selectedFolderFilter;
            folderFilterJSS = new JSONStorableString("folderFilter", selectedFolderFilter.GetFolderPath());
            inludeSubFoldersJSB = new JSONStorableBool("includeSubFolders", settings.defaultFilterSettings.inludeSubFoldersJSB.val, parentFiltersUI.SubFoldersCallback);

            resourceNameFilterJSS = new JSONStorableString("resourceNameFilter", "");
            resourceNameFilterQuick = resourceNameFilterJSS.val.ToLower();

            licenseFilterJSEnum = new JSONStorableEnumStringChooser("licenseFilter", LicenseType.enumManifestName, settings.defaultFilterSettings.licenseFilterJSEnum.val, "Package License", parentFiltersUI.LicenseCallback);

            selectModeJSEnum = new JSONStorableEnumStringChooser("selectMode", BrowserSelectMode.enumManifestName, settings.defaultFilterSettings.selectModeJSEnum.val, "Select Mode", parentFiltersUI.SelectModeCallback);
            sortModeJSEnum = new JSONStorableEnumStringChooser("sortMode", BrowserSortMode.enumManifestName, settings.defaultFilterSettings.sortModeJSEnum.val, "Order by", parentFiltersUI.SortByCallback);
            
        }
        private void SettingsTagMainValChange(string i)
        {
            if (!TagManifest.GetTagNames(resourceType,atomPresetResourceType).Contains(i)) tagsFilterJSMultiEnum.valTopEnum=TagGroups.anyTags;
            else
            {
                RefreshCreatorFilters();
                Settings.SaveSettings();
            }
            
        }

        private void SettingsTagTopValChange(int i)
        {
            RefreshCreatorFilters();
            Settings.SaveSettings();
        }
        private void SettingsCreatorMainValChange(string i)
        {
            if (!CreatorManifest.GetAllCreatorNames().Contains(i)) creatorJSMultiEnum.valTopEnum = CreatorFilterChoices.all;
            else
            {
                RefreshLicenseFilters();
                Settings.SaveSettings();
            }
            
        }
        private void SettingsClothingCreatorMainValChange(string i)
        {
            if (!CreatorManifest.GetAllClothingCreatorNames().Contains(i)) clothingCreatorJSME.valTopEnum = ClothingCreatorFilterChoices.all;
            else
            {
                Settings.SaveSettings();
            }

        }
        private void SettingsClothingCreatorTopValChange(int i)
        {
            Settings.SaveSettings();
        }

        private void SettingsCreatorTopValChange(int i)
        {
            RefreshLicenseFilters();
            Settings.SaveSettings();
        }

        public virtual JSONClass GetJSON()
        {
            JSONClass defaultFilterSettingsJC = new JSONClass();
            creatorJSMultiEnum.StoreJSON(defaultFilterSettingsJC);

            showHiddenJSB.StoreJSON(defaultFilterSettingsJC);
            onlyFavouritesJSB.StoreJSON(defaultFilterSettingsJC);
            onlyNewJSB.StoreJSON(defaultFilterSettingsJC);

            tagsFilterJSMultiEnum.StoreJSON(defaultFilterSettingsJC);
            licenseFilterJSEnum.StoreJSON(defaultFilterSettingsJC);

            selectModeJSEnum.StoreJSON(defaultFilterSettingsJC);
            sortModeJSEnum.StoreJSON(defaultFilterSettingsJC);

            folderFilterJSS.valNoCallback = selectedFolderFilter.GetFolderPath();
            folderFilterJSS.StoreJSON(defaultFilterSettingsJC);
            inludeSubFoldersJSB.StoreJSON(defaultFilterSettingsJC);

            if (combiTagFilterEnabled) defaultFilterSettingsJC["combiTag"] = combiTag.GetJSON();

            return defaultFilterSettingsJC;
        }

        public virtual void RestoreJSON(JSONClass defaultFilterSettingsJC)
        {
            creatorJSMultiEnum.RestoreFromJSON(defaultFilterSettingsJC);

            showHiddenJSB.RestoreFromJSON(defaultFilterSettingsJC);
            onlyFavouritesJSB.RestoreFromJSON(defaultFilterSettingsJC);
            onlyNewJSB.RestoreFromJSON(defaultFilterSettingsJC);

            tagsFilterJSMultiEnum.RestoreFromJSON(defaultFilterSettingsJC);
            licenseFilterJSEnum.RestoreFromJSON(defaultFilterSettingsJC);

            selectModeJSEnum.RestoreFromJSON(defaultFilterSettingsJC);
            sortModeJSEnum.RestoreFromJSON(defaultFilterSettingsJC);

            if (defaultFilterSettingsJC["folderFilter"]!=null) folderFilterJSS.RestoreFromJSON(defaultFilterSettingsJC);
            if (defaultFilterSettingsJC["combiTag"] != null)
            {
                combiTagFilterEnabled = true;
                combiTag = new CombiTag(resourceType, atomPresetResourceType, defaultFilterSettingsJC["combiTag"].AsObject);
            }
            else combiTagFilterEnabled = false;

            selectedFolderFilter = FolderBrowser.GetFolder(folderFilterJSS.val, resourceType, atomPresetResourceType, true);
            inludeSubFoldersJSB.RestoreFromJSON(defaultFilterSettingsJC);
        }

        private void FolderFilterChangeNoSave(string val)
        {
            selectedFolderFilter = FolderBrowser.GetFolder(val, resourceType, atomPresetResourceType, true);
        }

        private void FolderFilterChange(string val)
        {
            selectedFolderFilter = FolderBrowser.GetFolder(val, resourceType, atomPresetResourceType, true);
            Settings.SaveSettings();
        }

        private void SettingsBoolChange(bool val)
        {
            Settings.SaveSettings();
        }
        private void SettingsStringChange(string val)
        {
            Settings.SaveSettings();
        }

        private void SettingsIntChange(int val)
        {
            Settings.SaveSettings();
        }

        public void RefreshTagFilters()
        {
            List<string> tags = TagManifest.GetTagNames(resourceType, atomPresetResourceType);
            tagsFilterJSMultiEnum.SetMainChoices(tags);
            if (tagsFilterJSMultiEnum.valType == JSONStorableMultiEnumStringChooser.mainValFlag)
            {
                if (!tags.Contains(tagsFilterJSMultiEnum.mainVal)) tagsFilterJSMultiEnum.valTopEnum = TagGroups.anyTags;
            }

            List<int> ignoreTagGroups = new List<int>();
            var tagCategories = TagManifest.GetTagCategories(resourceType, atomPresetResourceType).ToList();
            tagCategories.Remove(TagCategory.userDefined);
            tagCategories.Remove(TagCategory.combi);
            if (tagCategories.Count == 0) ignoreTagGroups.Add(TagGroups.noUserTags);
            if (resourceCategory != ResourceCategory.clothing) ignoreTagGroups.Add(TagGroups.wornClothingOnly);

            tagsFilterJSMultiEnum.SetTopEnum(TagGroups.enumManifestName, ignoreTagGroups);

            if (tagsFilterJSMultiEnum.valType == JSONStorableMultiEnumStringChooser.topEnumValFlag)
            {
                if (ignoreTagGroups.Contains(tagsFilterJSMultiEnum.valTopEnum)) tagsFilterJSMultiEnum.valTopEnum = TagGroups.anyTags;
            }
        }

        public void RefreshCreatorFilters()
        {
            HashSet<ResourceVersionGroupEntry> filteredRVGEs = new HashSet<ResourceVersionGroupEntry>(ResourceManifest.GetTagFilteredResourceGroups(this));

            CreatorManifest.UpdateCreatorChoices(creatorJSMultiEnum, filteredRVGEs, resourceType, atomPresetResourceType);           
        }

        public void RefreshClothingCreatorFilters()
        {
            HashSet<ResourceVersionGroupEntry> filteredRVGEs = new HashSet<ResourceVersionGroupEntry>(ResourceManifest.GetCreatorFilteredResourceGroups(this));


            CreatorManifest.UpdateClothingCreatorChoices(clothingCreatorJSME, filteredRVGEs, resourceType, atomPresetResourceType);
        }


        public void RefreshLicenseFilters()
        {
            if (creatorJSMultiEnum.valType!=JSONStorableMultiEnumStringChooser.topEnumValFlag || creatorJSMultiEnum.valTopEnum == CreatorFilterChoices.allVARs)
            {
                licenseFilterJSEnum.SetEnumChoices(LicenseType.enumManifestName, ResourceManifest.GetLicenseTypesByInverseFilters(this));
            }
        }
    }

    public class QuickFilterSettings
    {
        public static void AddQFS(ResourceBrowserFilterSettings filterSettings)
        {
            string quickFilterName = "Filter" + (_quickFilterSettingList.Count + 1).ToString();
            var quickFilterSettings = new QuickFilterSettings(filterSettings, quickFilterName);
            _quickFilterSettingList.Add(quickFilterSettings);
            Settings.SaveSettings();
        }

        public static void ModifyQFS(ResourceBrowserFilterSettings filterSettings, QuickFilterSettings qfs)
        {
            qfs.resourceBrowserFilterQuickSettings.CopyFrom(filterSettings);
            Settings.SaveSettings();
        }

        public static void RemoveQFS(QuickFilterSettings qfs)
        {
            quickFilterSettingList.Remove(qfs);
            Settings.SaveSettings();
        }

        public static JSONClass GetJSONClass()
        {
            JSONClass quickFiltersJC = new JSONClass();

            qfsMinimized.StoreJSON(quickFiltersJC);
            quickFiltersJC["QuickFilterButtons"] = GetJSONArray();
            

            return quickFiltersJC;
        }

        private static JSONArray GetJSONArray()
        {

            JSONArray quickFiltersJA = new JSONArray();
            foreach (var quickFilterSettings in _quickFilterSettingList)
            {
                quickFiltersJA.Add(quickFilterSettings.GetJSON());
            }

            return quickFiltersJA;
        }

        public static void RestoreJSONClass(JSONClass quickFiltersJC)
        {

            qfsMinimized.RestoreFromJSON(quickFiltersJC);
            RestoreJSONArray(quickFiltersJC["QuickFilterButtons"].AsArray);
        }

        private static void RestoreJSONArray(JSONArray quickFilterSettingsJA)
        {
            _quickFilterSettingList.Clear();

            foreach (JSONClass quickFilterJC in quickFilterSettingsJA)
            {
                var quickFilterSettings = new QuickFilterSettings(quickFilterJC);
                _quickFilterSettingList.Add(quickFilterSettings);
            }
        }

        public static int quickFilterSettingCount
        {
            get { return _quickFilterSettingList.Count; }
        }


        private static List<QuickFilterSettings> _quickFilterSettingList = new List<QuickFilterSettings>();
        public static List<QuickFilterSettings> quickFilterSettingList { get { return _quickFilterSettingList; } }

        public static JSONStorableBool qfsMinimized = new JSONStorableBool("qfsMinimized",false,Settings.SettingsBoolChange);

        public ResourceBrowserFilterSettings resourceBrowserFilterQuickSettings { get; private set; } = null;

        public int resourceType { get { return resourceBrowserFilterQuickSettings.resourceType; } }
        public string atomPresetResourceType { get { return resourceBrowserFilterQuickSettings.atomPresetResourceType; } }

        public string quickFilterName { get { return _quickFilterName; } set
            {
                _quickFilterName= value;
                Settings.SaveSettings();
            }
        }

        private string _quickFilterName ="";

        public QuickFilterSettings(ResourceBrowserFilterSettings filterSettings, string quickFilterName)
        {
            resourceBrowserFilterQuickSettings = new ResourceBrowserFilterSettings(filterSettings.resourceType, filterSettings.atomPresetResourceType);
            this.quickFilterName = quickFilterName;
            StoreFilterSettings(filterSettings);
            
        }

        public QuickFilterSettings(JSONClass quickFilterJC)
        {
            quickFilterName = quickFilterJC["name"];
            resourceBrowserFilterQuickSettings = new ResourceBrowserFilterSettings(quickFilterJC["resourceType"].AsInt, quickFilterJC["atomPresetResourceType"]);
            resourceBrowserFilterQuickSettings.RestoreJSON(quickFilterJC["filterSettings"].AsObject);
        }

        private void StoreFilterSettings (ResourceBrowserFilterSettings filterSettings)
        {
            resourceBrowserFilterQuickSettings.CopyFrom(filterSettings);

        }

        public JSONClass GetJSON()
        {
            var quickFilterJC = new JSONClass();
            quickFilterJC["name"] = quickFilterName;
            quickFilterJC["resourceType"].AsInt = resourceBrowserFilterQuickSettings.resourceType;
            quickFilterJC["atomPresetResourceType"] = resourceBrowserFilterQuickSettings.atomPresetResourceType;
            quickFilterJC["filterSettings"] = resourceBrowserFilterQuickSettings.GetJSON();

            return quickFilterJC;
        }
    }

}
