using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;
using MVR.FileManagementSecure;
using MeshVR;
using System.Security.AccessControl;
using static ZenFulcrum.EmbeddedBrowser.SayWordsOnTouch;
using System.Text.RegularExpressions;

namespace JayJayWon
{
    static class Const
    {
        public const string BAversion = "1.24.1";
        public const int BAMajorVersion = 1;
        public const int BAMinorVersion = 24;
        public const int BAFixVersion =1;

        public const int BAInteropVersion = 4;
        public const int SceneCacheVersion = 2;

        public const float _localCanvasScale = 0.003f;

        public const string VARLegacyCoreDataFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\VARMetaData";
        public const string VARResourcesCoreDataFilesFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\VARResourcesCoreData";
        public const string VARResourceDataFileName = "VARResourcesData";

        public const string VARGroupCoreDataFilesFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\VARGroupCoreData";
        public const string VARGroupDataFileName = "VARGroupData";


        public const string VARLegacyUserDataFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\VARUserData";
        public const string VARGroupUserDataFilesFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\VARGroupUserData";
        public const string VARResourcesUserDataFilesFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\VARResourcesUserData";

        public const string LocalLegacyUserDataFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\LocalUserData";
        public const string LocalResourcesUserDataFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\LocalResourcesUserData";

        public const string MetaDataBackupFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\MetaDataBackups";

        public const string SceneVARImportCacheFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\SceneImportCache\\VARs";
        public const string SceneLocalImportCacheFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\SceneImportCache\\Local";

        public const string LocalResourceDataFileName = "LocalResourcesData";


        public const string CreatorUserDataFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\CreatorUserData";
        public const string SymLinksFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\SymLinks";
        public const string BAScriptFolder = "Custom\\Scripts\\JayJayWon\\BrowserAssist";
        public const string BAScriptDataFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist";
        public const string DeletedFolderArchiveFolder = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\Archive\\DeletedFolders";

        public const string VARResourceThumbnails = "Saves\\PluginData\\JayJayWon\\BrowserAssist\\ResourceThumbnails\\VARPackages";

        public const string resourceThumbailsVAR = "JayJayWon.VARHubThumbnails";     
        public const int VARManifestStoreFormat = 3;
        public const int VARUserDataStoreFormat = 3;
        public const int LocalUserDataStoreFormat = 3;

        public const string CreatorMetaDataFileExt = ".creatorManifest";
        public const string CoreDataFileExt = ".manifest";
        public const string UserDataFileExt = ".userData";

        public static readonly List<string> BodyRegionTagNames = new List<string>() {"arms","feet","full body","hands","head","hip","legs","neck","torso" };

        public static readonly List<string> FemaleClothingTypeTagNames = new List<string>() { "accessory", "bodysuit", "bottom", "bra", "dress", "glasses", "gloves", "hat", "jewellry", "mask", "panties", "pants", "shirt", "shoes", "shorts", "skirt", "socks", "stockings", "sweater", "top", "underwear" };

        public static readonly List<string> MaleClothingTypeTagNames = new List<string>() { "accessory", "bodysuit","glasses", "gloves", "hat", "jacket", "mask", "pants", "shirt", "shoes", "shorts", "socks", "sweater", "trunks", "underwear", "vest" };


        public static Color UIhighlightColor = Color.cyan;

        public static List<string> GetResourceRootFolderNames (int resourceType, string atomPresetResourceType)
        {
            List<string> resourceRootFolders = new List<string> ();
            if (resourceType == ResourceType.scene) resourceRootFolders.Add("Saves\\scene");
            if (resourceType == ResourceType.presetAppearance) resourceRootFolders.Add("Custom\\Atom\\Person\\Appearance");
            if (resourceType == ResourceType.presetAnimation) resourceRootFolders.Add("Custom\\Atom\\Person\\AnimationPresets");
            if (resourceType == ResourceType.presetBreastPhys) resourceRootFolders.Add("Custom\\Atom\\Person\\BreastPhysics");
            if (resourceType == ResourceType.presetClothing) resourceRootFolders.Add("Custom\\Atom\\Person\\Clothing");
            if (resourceType == ResourceType.presetGlutePhysics) resourceRootFolders.Add("Custom\\Atom\\Person\\GlutePhysics");
            if (resourceType == ResourceType.presetHair) resourceRootFolders.Add("Custom\\Atom\\Person\\Hair");
            if (resourceType == ResourceType.presetMorphs) resourceRootFolders.Add("Custom\\Atom\\Person\\Morphs");
            if (resourceType == ResourceType.presetPlugins) resourceRootFolders.Add("Custom\\Atom\\Person\\Plugins");
            if (resourceType == ResourceType.presetPose) resourceRootFolders.Add("Custom\\Atom\\Person\\Pose");
            if (resourceType == ResourceType.presetSkin) resourceRootFolders.Add("Custom\\Atom\\Person\\Skin");
            if (resourceType == ResourceType.presetGeneral) resourceRootFolders.Add("Custom\\Atom\\Person\\General");
            if (resourceType == ResourceType.plugins) resourceRootFolders.Add("Custom\\Scripts");
            if (resourceType == ResourceType.subScenes) resourceRootFolders.Add("Custom\\SubScene");
            if (resourceType == ResourceType.cua) resourceRootFolders.Add("Custom\\Assets");
            if (resourceType == ResourceType.clothingItemPresets)
            {
                resourceRootFolders.Add("Custom\\Clothing\\Female");
                resourceRootFolders.Add("Custom\\Clothing\\Male");
            }
            if (resourceType == ResourceType.maleClothingItems) resourceRootFolders.Add("Custom\\Clothing\\Male");
            if (resourceType == ResourceType.femaleClothingItems) resourceRootFolders.Add("Custom\\Clothing\\Female");

            if (resourceType == ResourceType.presetAtom) resourceRootFolders.Add("Custom\\Atom\\"+ atomPresetResourceType);
            if (resourceType == ResourceType.presetSceneSessionPlugins) resourceRootFolders.Add("Custom\\PluginPresets");


            return resourceRootFolders;
        }
    }

    public static class Globals
    {
        public static BrowserAssist mvrScript;
        public static bool customFolderAccess = false;
        public static bool scenesFolderAccess = false;
        public static bool addonPackageFilePrefsFolderAccess = false;
        public static bool addonPackagesAccess = false;
        public static bool isVREnabled = false;
        public static bool debugLoadTimingEnabled = false;
        public static bool isFileCreateModifiedDateAvailable = false;
        public static bool isRealClothingAvailable = false;
        public static bool failureOnLocalMetaDataLoad = false;
        public static bool failureOnVARMetaDataLoad = false;
        public static bool overrideFailedStartupHalt = false;
        public static bool caseSensitiveFileSystem = false;
        public static bool browserPointerActive = false;
        public static bool validStartup { get
            {
                return (!Globals.failureOnLocalMetaDataLoad && !Globals.failureOnVARMetaDataLoad) || Globals.overrideFailedStartupHalt;
            } }

        public static HashSet<string> nonPersonAtomTypes = new HashSet<string>() { "AnimationPattern", "AnimationStep", "AptBook01", "AptBook02", "AptBookShelf", "AptChair", "AptCoffeeTable", "AptJacuzzi", "AptJacuzziProp", "AptJacuzziRailing", "AptLamp", "AptOutdoorLight", "AptPatioChair", "AptPicture01", "AptPicture02", "AptPlant", "AptPlanter", "AptRug", "AptSmartTV", "AptSmartWebTV", "AptSofa", "AptSpeaker", "AptTVStand", "AudioSource", "Button", "Capsule", "CityScape", "CityScapeNight", "ClothGrabSphere", "CollisionTrigger", "Crypt", "Cube", "CustomUnityAsset", "CyberpunkApartment", "CyberpunkApartmentDecor", "CyberpunkBed", "CyberpunkBedPillow01", "CyberpunkBedPillow02", "CyberpunkBedPillow03", "CyberpunkChair", "CyberpunkCoffeeTable", "CyberpunkComputer", "CyberpunkComputerChair", "CyberpunkControlScreen", "CyberpunkDresser01", "CyberpunkDresser02", "CyberpunkKeyboard", "CyberpunkLaptop", "CyberpunkLight", "CyberpunkMouse", "CyberpunkMousepad", "CyberpunkRemote", "CyberpunkSofa", "CyberpunkSofaCushion01", "CyberpunkSofaCushion02", "CyberpunkTable", "CyberpunkTablet", "CyberpunkWallLight01", "CyberpunkWallLight02", "CycleForce", "DecoDowntimeChair", "DecoDowntimeCoffeeTable", "DecoDowntimeSideTable", "DecoDowntimeStand", "Dildo", "DreamHomeTV", "DreamHomeWebTV", "DreamStreetBedroom", "DSBR_2TierTable", "DSBR_Bed", "DSBR_BedPillow", "DSBR_Bench", "DSBR_BuiltInShelves", "DSBR_Chair", "DSBR_DecorativePillow", "DSBR_Ottoman", "DSBR_Shelf", "DSBR_ThrowPillow", "Empty", "Glass", "Glass-Stained", "GrabPoint", "ImagePanel", "ImagePanelEmissive", "ImagePanelTransparent", "ImagePanelTransparentEmissive", "InvisibleLight", "InvisiblePanel", "ISCapsule", "ISCone", "ISCube", "ISCylinder", "IslBench", "IslFencePost", "IslFenceSection", "IslOverlook", "IslPatioChair", "IslPlantWFlowers", "IslPotA", "IslPotB", "IslPotSmall", "IslRailingGlass", "IslStool", "IslTerrain", "IslTopiary", "IslTree", "IslTreePlanter", "IslWallPost", "IslWallSection", "ISSphere", "ISTube", "LookAtTrigger", "LoungeChair", "ModernRoomBed", "ModernRoomLargeLamp", "OldStyleBed", "OldStyleChair", "OldStylePillow01", "OldStylePillow02", "OldStyleRoom", "OldStyleSideTable", "OldStyleVanityStool", "Paddle", "PlayerNavigationPanel", "ReflectiveSlate", "ReflectiveWoodPanel", "RhythmAudioSource", "RhythmForce", "SimpleSign", "SimSheet", "SkullQueenSword", "Slate", "SpaceBox", "Sphere", "SubScene", "SyncForce", "TechnoDancePole", "TechnoGirder", "TechnoLight", "TechnoLightBar", "TechnoLightBar+Light", "TechnoNeonCircle", "TechnoNeonCircle+Light", "TechnoNeonHeart", "TechnoNeonHeart+Light", "TechnoNeonSquare", "TechnoNeonSquare+Light", "TechnoNeonTriangle", "TechnoNeonTriangle+Light", "TechnoRingLight", "TechnoRingLight+Light", "TechnoRoom", "TechnoRoundCage", "TechnoRoundPlatform", "TechnoThrone", "Torch", "ToyAH", "ToyBP", "UIButton", "UISlider", "UIText", "UIToggle", "VaMLogo", "VaMSign", "VariableTrigger", "Wall", "WebBrowser", "WebPanel", "WebPanelEmissive", "WindowCamera", "WoodPanel"};
    }
    static class Utils
    {
        static public void AddBAVersionToJC(JSONClass jc)
        {
            jc["BAMajorVersion"].AsInt = Const.BAMajorVersion;
            jc["BAMinorVersion"].AsInt = Const.BAMinorVersion;
            jc["BAFixVersion"].AsInt = Const.BAFixVersion;
        }
        static public bool IsCaseSensitiveFileSystem(string path)
        {
            bool isCaseSensitive = true;
            if (FileManagerSecure.FileExists(path + "\\test.json"))FileManagerSecure.DeleteFile(path + "\\test.json");

            var jc = new JSONClass();
            jc["test"] = "Test";

            SuperController.singleton.SaveJSON(jc,path + "\\test.json");

            if (FileManagerSecure.FileExists(path + "\\TeSt.jsOn")) isCaseSensitive = false;

            FileManagerSecure.DeleteFile(path + "\\test.json");

            return isCaseSensitive;
        }
        static public DateTime FileLastWriteTime (string path)
        {
#if VAM_GT_1_21
           return FileManagerSecure.FileLastWriteTime (path);
#else
            return DateTime.MinValue;
#endif
        }
        static public DateTime FileCreationTime(string path)
        {
#if VAM_GT_1_21
            return FileManagerSecure.FileCreationTime(path);           
#else
            return DateTime.MinValue;
#endif
        }

        static public string GetUniqueFolderName(string folderNamePath, int maxAttempts =9999)
        {
            string uniqueFolderNamePath = folderNamePath;
            int folderUniqueID = 1;

            while (FileManagerSecure.DirectoryExists(uniqueFolderNamePath) && (maxAttempts<1 || folderUniqueID<maxAttempts))
            {
                uniqueFolderNamePath = folderNamePath+"("+folderUniqueID.ToString()+")";
                folderUniqueID++;
            }

            return uniqueFolderNamePath;
        }

        static public string GetUniqueFileName(string filePath, string fileNameNoExt, string fileNameExtension, int maxAttempts = 9999)
        {
            string uniqueFileNamePath = filePath+"\\"+ fileNameNoExt + "."+fileNameExtension;
            int fileUniqueID = 1;
            string uniqueFileName = fileNameNoExt;

            while (FileManagerSecure.FileExists(uniqueFileNamePath) && (maxAttempts < 1 || fileUniqueID < maxAttempts))
            {
                uniqueFileName = fileNameNoExt + "(" + fileUniqueID + ")";
                uniqueFileNamePath = filePath + "\\" + uniqueFileName + "."+ fileNameExtension;
                
                fileUniqueID++;
            }

            return uniqueFileName;
        }

        static public string GetUniquePresetName(string filePath, string presetName, int maxAttempts = 9999)
        {
            string uniqueFileNamePath = filePath + "\\Preset_" + presetName + ".vap";
            int fileUniqueID = 1;
            string uniquePresetName = presetName;

            while (FileManagerSecure.FileExists(uniqueFileNamePath) && (maxAttempts < 1 || fileUniqueID < maxAttempts))
            {
                uniquePresetName = presetName + "(" + fileUniqueID + ")";
                uniqueFileNamePath = filePath + "\\"+uniquePresetName + ".vap";
                
                fileUniqueID++;
            }

            return uniquePresetName;
        }


        static public bool CreatePluginDataFolder()
        {
            bool result = false;
            if (FileManagerSecure.DirectoryExists("Saves\\PluginData"))
            {
                if (!FileManagerSecure.DirectoryExists(Const.VARResourcesCoreDataFilesFolder)) FileManagerSecure.CreateDirectory(Const.VARResourcesCoreDataFilesFolder);
                if (!FileManagerSecure.DirectoryExists(Const.VARGroupCoreDataFilesFolder)) FileManagerSecure.CreateDirectory(Const.VARGroupCoreDataFilesFolder);

                if (!FileManagerSecure.DirectoryExists(Const.VARGroupUserDataFilesFolder)) FileManagerSecure.CreateDirectory(Const.VARGroupUserDataFilesFolder);
                if (!FileManagerSecure.DirectoryExists(Const.VARResourcesUserDataFilesFolder)) FileManagerSecure.CreateDirectory(Const.VARResourcesUserDataFilesFolder);

                if(!FileManagerSecure.DirectoryExists(Const.LocalResourcesUserDataFolder)) FileManagerSecure.CreateDirectory(Const.LocalResourcesUserDataFolder);

                if (!FileManagerSecure.DirectoryExists(Const.VARResourceThumbnails)) FileManagerSecure.CreateDirectory(Const.VARResourceThumbnails);

                if (!FileManagerSecure.DirectoryExists(Const.MetaDataBackupFolder)) FileManagerSecure.CreateDirectory(Const.MetaDataBackupFolder);

                if (!FileManagerSecure.DirectoryExists(Const.SceneVARImportCacheFolder)) FileManagerSecure.CreateDirectory(Const.SceneVARImportCacheFolder);

                if (!FileManagerSecure.DirectoryExists(Const.SceneLocalImportCacheFolder)) FileManagerSecure.CreateDirectory(Const.SceneLocalImportCacheFolder);

                if (FileManagerSecure.DirectoryExists(Const.VARResourcesCoreDataFilesFolder)) result = true;
            }
            else SuperController.LogMessage("BrowserAssist: this plugin requires the folder Saves\\PluginData to exist.");
            return (result);
        }

        static public HashSet<string> GetLocalFolderNamesRecursive(string path, string onlyFoldersWithFileExtensions="")
        {
            string[] directories = null;
            string[] files = null;
            try
            {
                directories = FileManagerSecure.GetDirectories(path);
                files = FileManagerSecure.GetFiles(path);
            }
            catch (Exception e) { SuperController.LogError("Exception in BA.Utils.GetLocalFolderNamesRecursive attepting to get Directories at " + path + ": " + e); }

            if (directories != null)
            {
                HashSet<string> directoryPaths = new HashSet<string>();
                if (onlyFoldersWithFileExtensions=="" || files.Where(x => x.EndsWith(onlyFoldersWithFileExtensions)).Count() > 0) directoryPaths.Add(path);

                foreach (string directory in directories)
                {
                    if (!(directory.EndsWith(".var:") || (directory.EndsWith(".var")&& files.Contains(directory+".orig")) || files.Contains(directory+".var")) )
                    {
                        directoryPaths.UnionWith(GetLocalFolderNamesRecursive(directory, onlyFoldersWithFileExtensions));
                    }
                }
                return directoryPaths;
            }

            return null;
        }

        static public HashSet<string> GetFilesAtPathRecursive(string path, string pattern, bool ignoreDisabledFiles = false, bool includeMatchingVARFolderNames = false)
        {
            string[] patterns = new string[1];
            patterns[0] = pattern;
            return GetFilesAtPathRecursive(path, patterns, ignoreDisabledFiles, includeMatchingVARFolderNames);
        }

        static public HashSet<string> GetFilesAtPathRecursive(string path, string[] patterns, bool ignoreDisabledFiles = false, bool includeMatchingVARFolderNames = false)
        {
            IEnumerable<string> files = null;

            try
            {
                if (patterns.Contains("*.*")) files = FileManagerSecure.GetFiles(path);
                else if (Globals.caseSensitiveFileSystem) files = FileManagerSecure.GetFiles(path).Where(fn => patterns.Contains("*." + fn.Substring(fn.LastIndexOf('.') + 1)));
                else files = FileManagerSecure.GetFiles(path).Where(fn => patterns.Contains("*." + fn.Substring(fn.LastIndexOf('.') + 1).ToLower()));
            }
            catch (Exception e) { SuperController.LogError("Exception in BA.Utils.GetFilesAtPathRecursive attepting to get Files at " + path + ": " + e); }

            string[] directories = null;
            try
            {
                directories = FileManagerSecure.GetDirectories(path);
            }
            catch (Exception e) { SuperController.LogError("Exception in BA.Utils.GetFilesAtPathRecursive attepting to get Directories at " + path + ": " + e); }

            HashSet<string> combined;
            if (files != null) combined = new HashSet<string>(files);
            else combined = new HashSet<string>();

            if (includeMatchingVARFolderNames && directories!=null && patterns.Contains("*.var"))
            {
                foreach (string directory in directories)
                {
                    if (directory.EndsWith(".var:"))
                    {                       
                        string varFolderName = directory.Substring(0, directory.Length - 1);
                        combined.Add(varFolderName);
                    }
                   
                }
            }
           
            if (ignoreDisabledFiles & files != null)
            {

                HashSet<string> disabledVARFiles = new HashSet<string>();
                foreach (string file in combined)
                {
                    if (FileManagerSecure.FileExists(file + ".disabled"))
                    {
                        disabledVARFiles.Add(file);
                    }
                }
                combined.ExceptWith(disabledVARFiles);
            }


            if (directories != null)
            {
                directories.ToList().ForEach(directory =>
                {
                   if (!directory.EndsWith(".var:")) combined.UnionWith(GetFilesAtPathRecursive(directory, patterns, ignoreDisabledFiles, includeMatchingVARFolderNames));

                });
            }

            return combined;
        }

        public static void CopyFolders(string sourceFolder, string targetFolder, string filesStartsWithFilter=null)
        {
            foreach (var file in FileManagerSecure.GetFiles(sourceFolder))
            {
                string fileName = FileManagerSecure.GetFileName(file);
                if (filesStartsWithFilter == null || fileName.StartsWith(filesStartsWithFilter))
                {
                    FileManagerSecure.CopyFile(file, targetFolder + "\\" + fileName);
                }
            }

            foreach (var folder in FileManagerSecure.GetDirectories(sourceFolder))
            {
                string folderName = FileManagerSecure.GetDirectoryName(folder);
                FileManagerSecure.CreateDirectory(targetFolder + "\\" + folderName);
                CopyFolders(sourceFolder+"\\+folderName",targetFolder+"\\"+folderName,filesStartsWithFilter);

            }

        }

        public static string GetLatestVARPath(string path)
        {
            if (!path.Contains(".latest:") && path.Contains(":") && path.IndexOf(':') > 1)
            {
                string varPackageName = path.Substring(0, path.IndexOf(':'));
                string varFileName = path.Substring(varPackageName.Length + 1);
                path = varPackageName.Substring(0, varPackageName.LastIndexOf('.')) + ".latest:" + varFileName;
            }
            path = SuperController.singleton.NormalizeLoadPath(path);

            return (path);
        }
        static public void LogDebug(string message)
        {
            SuperController.LogMessage("BrowserAssist: " + message);
        }

        static public void LogProcessTime(string message, int count, double timeInSeconds)
        {
            if (count>0)
            SuperController.LogMessage(count.ToString() + message + timeInSeconds.ToString("0.000") + " seconds " + "(Rate: "+(count/timeInSeconds).ToString("0.00")+" per second");
            else
                SuperController.LogMessage(message + timeInSeconds.ToString("0.000") + " seconds");
        }

        public static int IndexOfNth(this string str, string value, int nth = 0)
        {
            if (nth < 0)
                throw new ArgumentException("Can not find a negative index of substring in string. Must start with 0");

            int offset = str.IndexOf(value);
            for (int i = 0; i < nth; i++)
            {
                if (offset == -1) return -1;
                offset = str.IndexOf(value, offset + 1);
            }

            return offset;
        }

        public static void DeleteAllFilesRecursive(string targetFolderName)
        {
            try
            {
                if (FileManagerSecure.FileExists(targetFolderName))
                {
                    var files = FileManagerSecure.GetFiles(targetFolderName);
                    foreach (string file in files)
                    {
                        FileManagerSecure.DeleteFile(file);
                    }
                    var folders = FileManagerSecure.GetDirectories(targetFolderName);
                    foreach (string folder in folders)
                    {
                        DeleteAllFilesRecursive(folder);
                    }
                }
                
            }
            catch (Exception e)
            {
                SuperController.LogError("BA.Utils.DeleteAllFilesRecursive: Exception trying to delete files in folder " + targetFolderName + "\n" + e);
                return;
            }
        }

        public static void DeleteFolder(string deleteFolderPath, UserActionCallback userActionCallback=null, ExceptionCallback exceptionCallback = null)
        {
            
            string uniqueFolderName = Const.DeletedFolderArchiveFolder + "\\" + DateTime.Now.ToString("yyyyMMddHHmmss");

            try
            {
                int incr = 1;
                while (FileManagerSecure.DirectoryExists(uniqueFolderName + incr.ToString()))
                {
                    incr++;
                }
                uniqueFolderName = uniqueFolderName + incr.ToString();
                FileManagerSecure.CreateDirectory(uniqueFolderName);

            }
            catch (Exception e)
            {
                SuperController.LogError("BA.Utils.DeleteFolder: Exception trying to create Deleted Folders Archive folder.\n" + e);
                if (exceptionCallback != null) exceptionCallback(e);
                return;
            }

            try
            {
                string deleteFolder = deleteFolderPath.Substring(deleteFolderPath.LastIndexOf("\\") + 1);
                string targetFolderName = uniqueFolderName + "\\" + deleteFolder;

                if ((deleteFolderPath.ToLower().StartsWith("custom\\") && Globals.customFolderAccess) || (deleteFolderPath.ToLower().StartsWith("saves\\scene") && Globals.scenesFolderAccess) || (deleteFolderPath.ToLower().StartsWith("addonpackages\\") && Globals.addonPackagesAccess) || (deleteFolderPath.ToLower().StartsWith("addonpackagesfileprefs\\") && Globals.addonPackageFilePrefsFolderAccess))
                {
                    deleteFolderPath = Const.SymLinksFolder + "\\" + deleteFolderPath;
                }

                var deferredDeletion = new DeferredPluginDataFolderDeletion(uniqueFolderName, userActionCallback);

                FileManagerSecure.MoveFile(deleteFolderPath, targetFolderName, deferredDeletion.DeleteNow, null, exceptionCallback);

            }
            catch (Exception e)
            {
                SuperController.LogError("BA.Utils.DeleteFolder: Exception trying to move folder to Deleted Folders Archive folder.\n" + e);
                if (exceptionCallback != null) exceptionCallback(e);
                return;
            }

        }

    }

    public class DeferredPluginDataFolderDeletion
    {
        private string deleteFolderPath="";
        private UserActionCallback userActionCallback;

        public DeferredPluginDataFolderDeletion(string deleteFolderPath, UserActionCallback userActionCallback)
        {
            this.deleteFolderPath = deleteFolderPath;
            this.userActionCallback= userActionCallback;
        }

        public void DeleteNow()
        {            
            Utils.DeleteAllFilesRecursive(deleteFolderPath);
            if (userActionCallback!=null) userActionCallback();
        }

    }

    public static class ImageUtils
    {
        public static ImageLoaderThreaded.QueuedImage QueueLoadTexture(string url, ImageLoaderThreaded.ImageLoaderCallback callback, bool immediate)
        {
            if (ImageLoaderThreaded.singleton == null)
                return null;


            ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
            queuedImage.imgPath = url;
            queuedImage.forceReload = true;
            queuedImage.skipCache = true;
            queuedImage.compress = true;
            queuedImage.createMipMaps = false;
            queuedImage.isNormalMap = false;
            queuedImage.linear = false;
            queuedImage.createAlphaFromGrayscale = false;
            queuedImage.createNormalFromBump = false;
            queuedImage.bumpStrength = 0f;
            queuedImage.isThumbnail = true;
            queuedImage.fillBackground = false;
            queuedImage.invert = false;
            queuedImage.callback = callback;
/*
            Texture2D tex = ImageLoaderThreaded.singleton.GetCachedThumbnail(url);
            if (tex != null)
            {
                if (url.Contains("OL1")) SuperController.LogMessage("cached thumbnail OL1");
                else SuperController.LogMessage(url);
                queuedImage.tex = tex;
                callback.Invoke(queuedImage);
            }
            else
            {
                if (immediate) ImageLoaderThreaded.singleton.QueueThumbnailImmediate(queuedImage);
                else ImageLoaderThreaded.singleton.QueueThumbnail(queuedImage);
            }
*/
            if (immediate) ImageLoaderThreaded.singleton.QueueThumbnailImmediate(queuedImage);
            else ImageLoaderThreaded.singleton.QueueThumbnail(queuedImage);

            return queuedImage;
        }
    }

    public static class AtomUtils
    {
        public static List<string> GetPersonAtomNames(bool includeFemale, bool includeMale)
        {
            List<Atom> atoms = GetAtoms(false, false, false, true, false);
            List<string> atomNames = new List<string>();

            foreach (Atom atom in atoms)
            {
                bool isFemale = IsFemale(atom);
                if (isFemale && includeFemale) atomNames.Add(atom.name);
                if (!isFemale && includeMale) atomNames.Add(atom.name);
            }
            return atomNames;
        }
        public static List<Atom> GetPersonAtoms(bool includeFemale, bool includeMale)
        {
            List<Atom> allAtoms = GetAtoms(false, false, false, true, false);
            List<Atom> personAtoms = new List<Atom>();

            foreach (Atom atom in allAtoms)
            {
                bool isFemale = IsFemale(atom);
                if (isFemale && includeFemale) personAtoms.Add(atom);
                if (!isFemale && includeMale) personAtoms.Add(atom);
            }
            return personAtoms;
        }

        public static List<string> GetAtomNames(bool includeOffAtoms = false, bool includeCoreControl = false, bool includeCameraRig = false, bool includePersonAtoms = true, bool includeNonPersonAtoms = true, string atomTypeFilter = "")
        {
            List<Atom> atoms = GetAtoms(includeOffAtoms, includeCoreControl, includeCameraRig, includePersonAtoms, includeNonPersonAtoms);
            List<string> atomNames = new List<string>();
            foreach (Atom atom in atoms) atomNames.Add(atom.name);
            return atomNames;
        }
        public static List<Atom> GetAtoms(bool includeOffAtoms = false, bool includeCoreControl = false, bool includeCameraRig = false, bool includePersonAtoms = true, bool incudeNonPersonAtoms = true, string atomTypeFilter="")
        {
            List<Atom> atomsList = new List<Atom>();
            foreach (Atom atom in SuperController.singleton.GetAtoms())
            {
                if ((atom.on && (atom.containingSubScene == null || atom.containingSubScene.containingAtom.on)) || includeOffAtoms)
                {
                    if (atom.name == "CoreControl")
                    {
                        if (includeCoreControl && (atomTypeFilter == "" || atom.type == atomTypeFilter)) atomsList.Add(atom);
                    }
                    else if (atom.name == "[CameraRig]")
                    {
                        if (includeCameraRig && (atomTypeFilter == "" || atom.type == atomTypeFilter)) atomsList.Add(atom);
                    }
                    else if (atom.type == "Person" && includePersonAtoms && (atomTypeFilter == "" || atom.type == atomTypeFilter)) atomsList.Add(atom);
                    else if (atom.type != "Person" && incudeNonPersonAtoms && (atomTypeFilter == "" || atom.type == atomTypeFilter)) atomsList.Add(atom);
                }
            }

            return (atomsList);
        }

        public static bool IsMale(Atom atom)
        {
            bool isMale = false;
            // If the peson atom is not "On", then we cant determine their gender it seems as GetComponentInChildren<DAZCharacter> just returns null
            if (atom.on && (atom.containingSubScene == null || atom.containingSubScene.containingAtom.on) && atom.type == "Person") isMale = atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("male") ||
                    atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarlee") ||
                    atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarjulian") ||
                    atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("Futa");
            return (isMale);
        }

        public static bool IsFemale(Atom atom)
        {
            bool isFemale = false;
            // If the peson atom is not "On", then we cant determine their gender it seems as GetComponentInChildren<DAZCharacter> just returns null
            if (atom.on && (atom.containingSubScene == null || atom.containingSubScene.containingAtom.on) && atom.type == "Person" && !IsMale(atom)) isFemale = true;
            return (isFemale);
        }

        public static string GetNextAvailableAtomName(string preferredAtomName)
        {
            List<Atom> atoms = GetAtoms(true, true, true);
            List<string> atomNames = new List<string>();
            foreach (Atom tempAtom in atoms) atomNames.Add(tempAtom.uid);

            if (atomNames.Contains(preferredAtomName))
            {
                for (int i = 2; i < 10000; i++)
                {
                    string newAtomName = preferredAtomName + "#" + i.ToString();
                    if (!atomNames.Contains(newAtomName)) return newAtomName;
                }
            }
            else return preferredAtomName;
            return "";
        }

        public static void TeleportAtomToSpawnPoint(string teleportAtomName, Vector3 position, Quaternion rotation)
        {
            Atom atom = SuperController.singleton.GetAtomByUid(teleportAtomName);
            if (atom != null)
            {
                JSONClass atomsJSON = SuperController.singleton.GetSaveJSON(atom);
                JSONArray atomsArrayJSON = atomsJSON["atoms"].AsArray;
                JSONClass atomJSON = (JSONClass)atomsArrayJSON[0];

                JSONArray storablesArrayJSON = atomJSON["storables"].AsArray;

                atomJSON["position"]["x"].AsFloat = position.x;
                atomJSON["position"]["y"].AsFloat = position.y;
                atomJSON["position"]["z"].AsFloat = position.z;
                atomJSON["containerPosition"]["x"].AsFloat = position.x;
                atomJSON["containerPosition"]["y"].AsFloat = position.y;
                atomJSON["containerPosition"]["z"].AsFloat = position.z;
                atomJSON["rotation"]["x"].AsFloat = rotation.eulerAngles.x;
                atomJSON["rotation"]["y"].AsFloat = rotation.eulerAngles.y;
                atomJSON["rotation"]["z"].AsFloat = rotation.eulerAngles.z;
                atomJSON["containerRotation"]["x"].AsFloat = rotation.eulerAngles.x;
                atomJSON["containerRotation"]["y"].AsFloat = rotation.eulerAngles.y;
                atomJSON["containerRotation"]["z"].AsFloat = rotation.eulerAngles.z;

                Dictionary<string, int> storablesIndexDict = new Dictionary<string, int>();

                for (int i = 0; i < storablesArrayJSON.Count; i++)
                {
                    JSONClass storableJSON = (JSONClass)storablesArrayJSON[i];
                    storablesIndexDict.Add(storableJSON["id"].Value, i);
                    if (storableJSON["id"].Value == "control")
                    {
                        atomJSON["storables"][i]["position"]["x"].AsFloat = position.x;
                        atomJSON["storables"][i]["position"]["y"].AsFloat = position.y;
                        atomJSON["storables"][i]["position"]["z"].AsFloat = position.z;
                    }
                    if (storableJSON["id"].Value == "hip")
                    {
                        atomJSON["storables"][i]["rootPosition"]["x"].AsFloat = position.x;
                        atomJSON["storables"][i]["rootPosition"]["y"].AsFloat = atomJSON["storables"][i]["rootPosition"]["y"].AsFloat + position.y;
                        atomJSON["storables"][i]["rootPosition"]["z"].AsFloat = position.z;
                    }
                    if (storableJSON["id"].Value.StartsWith("hair"))
                    {
                        atomJSON["storables"][i]["position"]["x"].AsFloat = atomJSON["storables"][i]["position"]["x"].AsFloat + position.x;
                        atomJSON["storables"][i]["position"]["y"].AsFloat = atomJSON["storables"][i]["position"]["y"].AsFloat + position.y;
                        atomJSON["storables"][i]["position"]["z"].AsFloat = atomJSON["storables"][i]["position"]["z"].AsFloat + position.z;
                    }

                    if (storableJSON["id"].Value == "control" || storableJSON["id"].Value == "hip" || storableJSON["id"].Value.StartsWith("hair"))
                    {
                        string rotationKeyName = "";
                        if (storableJSON["id"].Value == "hip") rotationKeyName = "rootRotation";
                        else rotationKeyName = "rotation";
                        atomJSON["storables"][i][rotationKeyName]["x"].AsFloat = rotation.eulerAngles.x;
                        atomJSON["storables"][i][rotationKeyName]["y"].AsFloat = rotation.eulerAngles.y;
                        atomJSON["storables"][i][rotationKeyName]["z"].AsFloat = rotation.eulerAngles.z;
                    }
                }

                atom.PreRestore();
                atom.RestoreTransform(atomJSON);
                atom.Restore(atomJSON);
                atom.LateRestore(atomJSON);
                atom.PostRestore();

            }

        }

        public static IEnumerator CreateAtom(string atomType, string atomName, Action<string> onAtomCreated)
        {
            string newAtomName = atomName;
            try
            {                
                if (atomName == "") newAtomName = atomType;

                newAtomName = GetNextAvailableAtomName(newAtomName);
            }
            catch (Exception e)
            {
                SuperController.LogError("BA.AtomUtils.CreateAtom: Exception1 caught:\n" + e);
            }

            yield return SuperController.singleton.AddAtomByType(atomType, newAtomName);

            try
            {
                onAtomCreated(newAtomName);
            }
            catch (Exception e)
            {
                SuperController.LogError("BA.AtomUtils.CreateAtom: Exception2 caught:\n" + e);
            }
            
        }

        public static HashSet<DAZClothingItem> GetDAZClothingItems(Atom atom)
        {
            var dazClothingItems = new HashSet<DAZClothingItem>(atom.GetComponentsInChildren<DAZClothingItem>());

            return dazClothingItems;
        }

        private static Dictionary<Atom, HashSet<JSONStorableBool>> clothingItemJSBsByAtom = new Dictionary<Atom, HashSet<JSONStorableBool>>();

        public static void OnAtomAdded(Atom atom)
        {
            if (atom.type != "Person") return;

            if (clothingItemJSBsByAtom.ContainsKey(atom)) clothingItemJSBsByAtom.Remove(atom);

            JSONStorable geometryReceiver = atom.GetStorableByID("geometry");

            var clothingItemJSBs = new HashSet<JSONStorableBool>();

            foreach (var jsbName in geometryReceiver.GetBoolParamNames())
            {
                if (jsbName.StartsWith("clothing:"))
                {
                    var clothingItemJSB = geometryReceiver.GetBoolJSONParam(jsbName);

                    clothingItemJSB.setJSONCallbackFunction += ClothingItemJSBCallback;
                    clothingItemJSBs.Add(clothingItemJSB);

                }
            }

            clothingItemJSBsByAtom.Add(atom, clothingItemJSBs);
        }

        public static void ClothingItemJSBCallback(JSONStorableBool jsb)
        {
            Atom atom = jsb.storable.containingAtom;
            
            ResourcePrimaryActionUI.ClearCachedDCIs(atom);
            var mainBrowserUI = BrowserAssist.mainBrowserUI;

            if (mainBrowserUI.resourceActionsUI != null && mainBrowserUI.resourceActionsUI.primaryActionUITab != null) mainBrowserUI.resourceActionsUI.primaryActionUITab.RefreshActiveClothing();

            // Refresh the Clothing Item Browser on clothing item being worn or removed
            if (mainBrowserUI.resourceActionsUI != null && mainBrowserUI.resourceActionsUI.currentActionUITabType == ActionUITabType.clothingPresetTab)
            {
                var filtersResourceType = mainBrowserUI.browserFiltersUI.currentResourceType;
                var filtersAtomPresetResourceType = mainBrowserUI.browserFiltersUI.currentAtomPresetResourceType;
                var targetAtomJSMultiEnum = mainBrowserUI.resourceActionsUI.primaryActionUITab.targetAtomJSMultiEnum;
                var primaryRVGE = mainBrowserUI.resourceSelectionsUI.GetFirstSelectedRVGE(filtersResourceType, filtersAtomPresetResourceType);
                var resourceClothingPresetsActionUI = mainBrowserUI.resourceActionsUI.currentActionUITab as ResourceClothingPresetsActionUI;

                if (targetAtomJSMultiEnum.valType == JSONStorableMultiEnumStringChooser.mainValFlag && AtomUtils.GetClothingActive(SuperController.singleton.GetAtomByUid(targetAtomJSMultiEnum.mainVal), primaryRVGE).val)
                {
                    if (!resourceClothingPresetsActionUI.isNewPresetActive) resourceClothingPresetsActionUI.RefreshUI();
                }
                else if (resourceClothingPresetsActionUI.isNewPresetActive)
                {
                    resourceClothingPresetsActionUI.RefreshUI();
                }
            }
        }

        public static void OnAtomRemoved(Atom atom)
        {
            if (atom.type != "Person") return;

            if (clothingItemJSBsByAtom.ContainsKey(atom))
            {
                foreach (var clothingItemJSB in clothingItemJSBsByAtom[atom]) clothingItemJSB.setJSONCallbackFunction -= ClothingItemJSBCallback;
                clothingItemJSBsByAtom.Remove(atom);
            }

            ResourcePrimaryActionUI.ClearCachedDCIs(atom);
        }

        public static JSONStorableBool GetClothingActive(Atom atom, ResourceVersionGroupEntry rvge)
        {
            if (rvge.resourceCategory == ResourceCategory.clothing && atom.type == "Person")
            {
                string normalizedPath = FileManagerSecure.NormalizePath(rvge.resourceFullPathReference);
                JSONStorable receiver = atom.GetStorableByID("geometry");
                if (receiver != null)
                {
                    JSONStorableBool activeJSB = receiver.GetBoolJSONParam("clothing:" + normalizedPath);
                    return activeJSB;
                }
            }
            return null;
            
        }

        public static bool IsAtomNameGeneric(string atomName, string atomType)
        {
            string atomNameLowerCase = atomName.ToLower();

            if (atomNameLowerCase.Contains(atomType.ToLower())) return true;

            if (atomType == "Person")
            {
                if (new string[] {"guy","girl","female","male","dude", "person" }.Any(s=> atomNameLowerCase.Contains(s))) return true;
            }

            return false;
        }

        public static List<string> GetPersonNodeChoices()
        {
            List<string> nodeChoices = new List<string>();
            nodeChoices.Add("control");
            nodeChoices.Add("headControl");
            nodeChoices.Add("head");
            nodeChoices.Add("Lips");
            nodeChoices.Add("Mouth");
            nodeChoices.Add("neckControl");
            nodeChoices.Add("neck");
            nodeChoices.Add("lShoulderControl");
            nodeChoices.Add("lCollar");
            nodeChoices.Add("lPectoral");
            nodeChoices.Add("lArmControl");
            nodeChoices.Add("lShldr");
            nodeChoices.Add("lElbowControl");
            nodeChoices.Add("lForeArm");
            nodeChoices.Add("lHandControl");
            nodeChoices.Add("lHand");
            nodeChoices.Add("rShoulderControl");
            nodeChoices.Add("rCollar");
            nodeChoices.Add("rPectoral");
            nodeChoices.Add("rArmControl");
            nodeChoices.Add("rShldr");
            nodeChoices.Add("rElbowControl");
            nodeChoices.Add("rForeArm");
            nodeChoices.Add("rHandControl");
            nodeChoices.Add("rHand");

            nodeChoices.Add("chestControl");
            nodeChoices.Add("chest");
            nodeChoices.Add("lNippleControl");
            nodeChoices.Add("lNipple");
            nodeChoices.Add("rNippleControl");
            nodeChoices.Add("rNipple");

            nodeChoices.Add("abdomen2Control");
            nodeChoices.Add("abdomen2");
            nodeChoices.Add("pelvisControl");
            nodeChoices.Add("pelvis");
            nodeChoices.Add("hipControl");
            nodeChoices.Add("hip");
            nodeChoices.Add("abdomenControl");
            nodeChoices.Add("abdomen");
            nodeChoices.Add("LGlute");
            nodeChoices.Add("RGlute");

            nodeChoices.Add("testesControl");
            nodeChoices.Add("penisBaseControl");
            nodeChoices.Add("penisMidControl");
            nodeChoices.Add("penisTipControl");

            nodeChoices.Add("Labia");
            nodeChoices.Add("Vagina");

            nodeChoices.Add("lThighControl");
            nodeChoices.Add("lThigh");
            nodeChoices.Add("lKneeControl");
            nodeChoices.Add("lShin");
            nodeChoices.Add("lFootControl");
            nodeChoices.Add("lFoot");
            nodeChoices.Add("lToeControl");

            nodeChoices.Add("rThighControl");
            nodeChoices.Add("rThigh");
            nodeChoices.Add("rKneeControl");
            nodeChoices.Add("rShin");
            nodeChoices.Add("rFootControl");
            nodeChoices.Add("rFoot");
            nodeChoices.Add("rToeControl");

            return nodeChoices;
        }

        public static void ResetAllSimClothing(Atom atom)
        {
            foreach (string receiverName in atom.GetStorableIDs())
            {
                JSONStorable receiver = atom.GetStorableByID(receiverName);
                if (receiver != null)
                {
                    if (receiver.storeId.Length >= 3 && receiver.storeId.Substring(receiver.storeId.Length - 3) == "Sim")
                    {
                        if (!receiver.GetColorParamNames().Contains("rootColor"))
                        {
                            JSONStorableBool simEnabledBool = receiver.GetBoolJSONParam("simEnabled");
                            if (simEnabledBool.val) receiver.CallAction("Reset");
                        }
                        
                    }            
                }
            }
        }
    }

    public static class PluginUtils
    {

        // This fuction assumes that the plugin is a Session plugin
        public static List<MVRScript> GetSessionPlugins(string pluginTypeFilter = null)
        {
            List<MVRScript> pluginList = new List<MVRScript>();
            foreach (Transform transform in Globals.mvrScript.manager.gameObject.transform.Find("Plugins"))
            {
                MVRScript script = transform.gameObject.GetComponent<MVRScript>();
                if (script != null && (pluginTypeFilter == null || script.name.EndsWith(pluginTypeFilter))) pluginList.Add(script);
            }

            return (pluginList);
        }

        public static List<MVRScript> GetScenePlugins(string pluginTypeFilter = null)
        {
            List<MVRScript> pluginList = new List<MVRScript>();

            foreach (Atom atom in SuperController.singleton.GetAtoms())
            {
                MVRPluginManager manager = atom.GetStorableByID("PluginManager") as MVRPluginManager;
                if (manager != null)
                {
                    foreach (Transform transform in manager.gameObject.transform.Find("Plugins"))
                    {
                        MVRScript pluginStorable = transform.gameObject.GetComponent<MVRScript>();
                        if (pluginStorable != null && (pluginTypeFilter == null || pluginStorable.name.EndsWith(pluginTypeFilter))) pluginList.Add(pluginStorable);
                    }
                }
            }

            return (pluginList);
        }
        public static List<MVRScript> GetSceneAndSessionPlugins(string pluginTypeFilter = null)
        {
            return (GetSessionPlugins(pluginTypeFilter).Concat(GetScenePlugins(pluginTypeFilter)).ToList());
        }

        public static List<MVRScript> GetPluginsFromAtom(Atom atom, string pluginTypeFilter = null)
        {
            List<MVRScript> plugins = new List<MVRScript>();

            MVRPluginManager manager = atom.GetStorableByID("PluginManager") as MVRPluginManager;
            if (manager != null)
            {
                foreach (Transform transform in manager.gameObject.transform.Find("Plugins"))
                {
                    MVRScript pluginStorable = transform.gameObject.GetComponent<MVRScript>();
                    if (pluginStorable != null && (pluginTypeFilter == null || pluginStorable.name.EndsWith(pluginTypeFilter))) plugins.Add(pluginStorable);
                }
            }

            return plugins;
        }

        public static List<string> GetPluginRefsOfType(MVRPluginManager manager, string pluginPath)
        {
            List<string> pluginRefs = new List<string>();
            if (manager != null)
            {
                JSONClass currentPlugins = manager.GetJSON(true, true, true);
                if (currentPlugins != null)
                {
                    foreach (KeyValuePair<string, JSONNode> kvp in (JSONClass)currentPlugins["plugins"])
                    {
                        if (kvp.Value.ToString().Substring(kvp.Value.ToString().LastIndexOfAny(new char[] { '/', '\\' }) + 1) == pluginPath.Substring(pluginPath.LastIndexOfAny(new char[] { '/', '\\' }) + 1) + "\"") pluginRefs.Add(kvp.Key);
                    }
                }
            }
            return (pluginRefs);
        }
        public static List<string> GetPluginRefsOfType(Atom atom, string pluginPath)
        {
            MVRPluginManager manager = atom.GetStorableByID("PluginManager") as MVRPluginManager;

            return GetPluginRefsOfType(manager, pluginPath);
        }

        public static List<string> GetSessionPluginRefsOfType(string pluginPath)
        {

            return GetPluginRefsOfType(Globals.mvrScript.manager, pluginPath);
        }

    }

    public class PresetOptionsStore
    {
        private int resourceType;
        private JSONStorable presetJS;

        private bool includePhysical;
        private bool includeAppearance;
        private bool includePose;


        public PresetOptionsStore(int resourceType, JSONStorable presetJS)
        {
            this.resourceType = resourceType;
            StoreOptions(presetJS);
        }

        private void StoreOptions(JSONStorable presetJS)
        {
            this.presetJS = presetJS;

            if (resourceType == ResourceType.presetMorphs)
            {
                JSONStorableBool includePhysicalJSB = presetJS.GetBoolJSONParam("includePhysical");
                includePhysical = includePhysicalJSB.val;
                includePhysicalJSB.val = Settings.morphPresetIncludePhysicalJSB.val;
                JSONStorableBool includeAppearanceJSB = presetJS.GetBoolJSONParam("includeAppearance");
                includeAppearance = includeAppearanceJSB.val;
                includeAppearanceJSB.val = Settings.morphPresetIncludeAppJSB.val;
            }
            if (resourceType == ResourceType.presetGeneral)
            {
                JSONStorableBool includePhysicalJSB = presetJS.GetBoolJSONParam("includePhysical");
                includePhysical = includePhysicalJSB.val;
                includePhysicalJSB.val = Settings.generalPresetIncludePhysicalJSB.val;

                JSONStorableBool includeAppearanceJSB = presetJS.GetBoolJSONParam("includeAppearance");
                includeAppearance = includeAppearanceJSB.val;
                includeAppearanceJSB.val = Settings.generalPresetIncludeAppJSB.val;

                JSONStorableBool includePoseJSB = presetJS.GetBoolJSONParam("includeOptional");
                includePose = includePoseJSB.val;
                includePoseJSB.val = Settings.generalPresetIncludePoseJSB.val;
            }

        }
    }

    public class PresetLockStore
    {
        public bool _generalPresetLock;
        public bool _appPresetLock;
        public bool _posePresetLock;
        public bool _animationPresetLock;
        public bool _glutePhysPresetLock;
        public bool _breastPhysPresetLock;
        public bool _pluginPresetLock;
        public bool _skinPresetLock;
        public bool _morphPresetLock;
        public bool _hairPresetLock;
        public bool _clothingPresetLock;

        public void StorePresetLocks(Atom atom, bool clearAllLocks = false, bool lockClothingPreset = false)
        {
            List<PresetManagerControl> pmControlList = atom.presetManagerControls;
            foreach (PresetManagerControl pmc in pmControlList)
            {
                if (pmc.name == "geometry") _generalPresetLock = pmc.lockParams;
                if (pmc.name == "AppearancePresets") _appPresetLock = pmc.lockParams;
                if (pmc.name == "PosePresets") _posePresetLock = pmc.lockParams;
                if (pmc.name == "AnimationPresets") _animationPresetLock = pmc.lockParams;
                if (pmc.name == "FemaleGlutePhysicsPresets") _glutePhysPresetLock = pmc.lockParams;
                if (pmc.name == "FemaleBreastPhysicsPresets") _breastPhysPresetLock = pmc.lockParams;
                if (pmc.name == "PluginPresets") _pluginPresetLock = pmc.lockParams;
                if (pmc.name == "SkinPresets") _skinPresetLock = pmc.lockParams;
                if (pmc.name == "MorphPresets") _morphPresetLock = pmc.lockParams;
                if (pmc.name == "HairPresets") _hairPresetLock = pmc.lockParams;
                if (pmc.name == "ClothingPresets") _clothingPresetLock = pmc.lockParams;

                if (pmc.name == "ClothingPresets" && lockClothingPreset) pmc.lockParams = true;
                else if (clearAllLocks)
                {
                    pmc.lockParams = false;
                }
            }

        }
        public void RestorePresetLocks(Atom atom)
        {
            List<PresetManagerControl> pmControlList = atom.presetManagerControls;
            foreach (PresetManagerControl pmc in pmControlList)
            {
                if (pmc.name == "geometry") pmc.lockParams = _generalPresetLock;
                if (pmc.name == "AppearancePresets") pmc.lockParams = _appPresetLock;
                if (pmc.name == "PosePresets") pmc.lockParams = _posePresetLock;
                if (pmc.name == "AnimationPresets") pmc.lockParams = _animationPresetLock;
                if (pmc.name == "FemaleGlutePhysicsPresets") pmc.lockParams = _glutePhysPresetLock;
                if (pmc.name == "FemaleBreastPhysicsPresets") pmc.lockParams = _breastPhysPresetLock;
                if (pmc.name == "PluginPresets") pmc.lockParams = _pluginPresetLock;
                if (pmc.name == "SkinPresets") pmc.lockParams = _skinPresetLock;
                if (pmc.name == "MorphPresets") pmc.lockParams = _morphPresetLock;
                if (pmc.name == "HairPresets") pmc.lockParams = _hairPresetLock;
                if (pmc.name == "ClothingPresets") pmc.lockParams = _clothingPresetLock;
            }
        }
    }

    public class AtomPositionRotationSync : MonoBehaviour
    {
        public JSONStorableFloat positionXJSF;
        public JSONStorableFloat positionYJSF ;
        public JSONStorableFloat positionZJSF;

        public JSONStorableFloat rotationXJSF ;
        public JSONStorableFloat rotationYJSF ;
        public JSONStorableFloat rotationZJSF ;

        private string atomName = null;

        public JSONStorableBool baAtomCollisionEnabledJSB;
        private JSONStorableBool atomCollisionEnabledJSB =null;
        
        public AtomPositionRotationSync()
        {
            positionXJSF = new JSONStorableFloat("positionX", 0f, UpdateTargetAtomPosRot, -4f, 4f, false);
            positionYJSF = new JSONStorableFloat("positionY", 0f, UpdateTargetAtomPosRot, - 2f, 2f, false);
            positionZJSF = new JSONStorableFloat("positionZ", 0f, UpdateTargetAtomPosRot, -4f, 4f, false); 
            rotationXJSF = new JSONStorableFloat("rotationX", 0f, UpdateTargetAtomPosRot, -180f, 180f, true);
            rotationYJSF = new JSONStorableFloat("rotationY", 0f, UpdateTargetAtomPosRot, -180f, 180f, true);
            rotationZJSF = new JSONStorableFloat("rotationZ", 0f, UpdateTargetAtomPosRot, -180f, 180f, true);
            baAtomCollisionEnabledJSB = new JSONStorableBool("baAtomCollisionEnabled", false, BAAtomCollisionEnabledCallback);
        }
        public virtual void SetAtomName(string _atomName)
        {
            atomName = _atomName;
            Atom atom = SuperController.singleton.GetAtomByUid(atomName);
            if (atom != null)
            {
                var receiver = atom.GetStorableByID("AtomControl");
                if (receiver != null)
                {
                    if (atomCollisionEnabledJSB!=null) atomCollisionEnabledJSB.setJSONCallbackFunction -= AtomCollisionEnabledCallback;
                    atomCollisionEnabledJSB = receiver.GetBoolJSONParam("collisionEnabled");
                    baAtomCollisionEnabledJSB.valNoCallback = atomCollisionEnabledJSB.val;
                    atomCollisionEnabledJSB.setJSONCallbackFunction += AtomCollisionEnabledCallback;
                    return;
                }               
            }
        }

        public void OnDestroy()
        {
            if (atomCollisionEnabledJSB != null) atomCollisionEnabledJSB.setJSONCallbackFunction -= AtomCollisionEnabledCallback;
        }
        private void BAAtomCollisionEnabledCallback(JSONStorableBool jsb)
        {
            if (atomCollisionEnabledJSB!=null) atomCollisionEnabledJSB.val = jsb.val;
        }

        private void AtomCollisionEnabledCallback(JSONStorableBool jsb)
        {
            if (jsb == atomCollisionEnabledJSB)
            {
                baAtomCollisionEnabledJSB.valNoCallback = atomCollisionEnabledJSB.val;
            }
        }
        public virtual Vector3 GetPosition()
        {
            return new Vector3(positionXJSF.val, positionYJSF.val, positionZJSF.val);
        }

        public virtual Quaternion GetRotation()
        {
            return Quaternion.Euler(rotationXJSF.val, rotationYJSF.val, rotationZJSF.val);
        }

        protected virtual void UpdateTargetAtomPosRot(float val)
        {
            if (atomName != null)
            {
                Atom atom = SuperController.singleton.GetAtomByUid(atomName);
                if (atom != null)
                {
                    FreeControllerV3 fcv3 = atom.freeControllers.First(fc => fc.name == "control");
                    fcv3.transform.position = GetPosition();
                    fcv3.transform.rotation = GetRotation();
                }
            }
        }

        protected virtual void UpdateInternalPosRot()
        {
            if (atomName != null)
            {
                Atom atom = SuperController.singleton.GetAtomByUid(atomName);
                if (atom != null)
                {
                    FreeControllerV3 fcv3 = atom.freeControllers.First(fc => fc.name == "control");
                    positionXJSF.valNoCallback = fcv3.transform.position.x;
                    positionYJSF.valNoCallback = fcv3.transform.position.y;
                    positionZJSF.valNoCallback = fcv3.transform.position.z;

                    float tempAngle = fcv3.transform.rotation.eulerAngles.x;
                    if (tempAngle > 180f) tempAngle -= 360f;
                    rotationXJSF.valNoCallback = tempAngle;
                    tempAngle = fcv3.transform.rotation.eulerAngles.y;
                    if (tempAngle > 180f) tempAngle -= 360f;
                    rotationYJSF.valNoCallback = tempAngle;
                    tempAngle = fcv3.transform.rotation.eulerAngles.z;
                    if (tempAngle > 180f) tempAngle -= 360f;
                    rotationZJSF.valNoCallback = tempAngle;
                }
            }
        }

        void Update()
        {
            UpdateInternalPosRot();
        }
    }

    public class RelativeAtomPositionRotation : AtomPositionRotationSync
    {
        public static List<string> GetTargetNodeChoices()
        {
            List<string> nodeChoices = new List<string>();
            nodeChoices.Add("control");
            nodeChoices.Add("headControl");
            nodeChoices.Add("head");
            nodeChoices.Add("Lips");
            nodeChoices.Add("Mouth");
            nodeChoices.Add("neckControl");
            nodeChoices.Add("neck");
            nodeChoices.Add("lShoulderControl");
            nodeChoices.Add("lCollar");
            nodeChoices.Add("lPectoral");
            nodeChoices.Add("lArmControl");
            nodeChoices.Add("lShldr");
            nodeChoices.Add("lElbowControl");
            nodeChoices.Add("lForeArm");
            nodeChoices.Add("lHandControl");
            nodeChoices.Add("lHand");
            nodeChoices.Add("rShoulderControl");
            nodeChoices.Add("rCollar");
            nodeChoices.Add("rPectoral");
            nodeChoices.Add("rArmControl");
            nodeChoices.Add("rShldr");
            nodeChoices.Add("rElbowControl");
            nodeChoices.Add("rForeArm");
            nodeChoices.Add("rHandControl");
            nodeChoices.Add("rHand");

            nodeChoices.Add("chestControl");
            nodeChoices.Add("chest");
            nodeChoices.Add("lNippleControl");
            nodeChoices.Add("lNipple");
            nodeChoices.Add("rNippleControl");
            nodeChoices.Add("rNipple");

            nodeChoices.Add("abdomen2Control");
            nodeChoices.Add("abdomen2");
            nodeChoices.Add("pelvisControl");
            nodeChoices.Add("pelvis");
            nodeChoices.Add("hipControl");
            nodeChoices.Add("hip");
            nodeChoices.Add("abdomenControl");
            nodeChoices.Add("abdomen");
            nodeChoices.Add("LGlute");
            nodeChoices.Add("RGlute");

            nodeChoices.Add("testesControl");
            nodeChoices.Add("penisBaseControl");
            nodeChoices.Add("penisMidControl");
            nodeChoices.Add("penisTipControl");

            nodeChoices.Add("Labia");
            nodeChoices.Add("Vagina");

            nodeChoices.Add("lThighControl");
            nodeChoices.Add("lThigh");
            nodeChoices.Add("lKneeControl");
            nodeChoices.Add("lShin");
            nodeChoices.Add("lFootControl");
            nodeChoices.Add("lFoot");
            nodeChoices.Add("lToeControl");

            nodeChoices.Add("rThighControl");
            nodeChoices.Add("rThigh");
            nodeChoices.Add("rKneeControl");
            nodeChoices.Add("rShin");
            nodeChoices.Add("rFootControl");
            nodeChoices.Add("rFoot");
            nodeChoices.Add("rToeControl");

            return nodeChoices;
        }

        public JSONStorableEnumStringChooser posXRelAbsJSE;
        public JSONStorableEnumStringChooser posYRelAbsJSE;
        public JSONStorableEnumStringChooser posZRelAbsJSE;

        public JSONStorableEnumStringChooser rotXRelAbsJSE;
        public JSONStorableEnumStringChooser rotYRelAbsJSE;
        public JSONStorableEnumStringChooser rotZRelAbsJSE;

        public JSONStorableMultiEnumStringChooser relativeAtomNameJSME;
        public JSONStorableStringChooser relativeNodeNameJSSC;

        private GameObject guideAtom;
        private bool guideAtomVisible = false;

        public bool isRelativePosition
        {
            get
            {
                if (posXRelAbsJSE.val == AbsoluteRelative.rel) return true;
                if (posYRelAbsJSE.val == AbsoluteRelative.rel) return true;
                if (posZRelAbsJSE.val == AbsoluteRelative.rel) return true;
                return false;
            }
        }
        public bool isRelativeRotation
        {
            get
            {
                if (rotXRelAbsJSE.val == AbsoluteRelative.rel) return true;
                if (rotYRelAbsJSE.val == AbsoluteRelative.rel) return true;
                if (rotZRelAbsJSE.val == AbsoluteRelative.rel) return true;

                return false;
            }
        }

        public RelativeAtomPositionRotation() : base()
        {

        }

        public void CopyFrom(RelativeAtomPositionRotation rapr)
        {
            JSONClass jc = new JSONClass();
            rapr.StoreJSON(jc);
            RestoreFromJSON(jc);
        }

        public void RestoreFromJSON(JSONClass jc)
        {
            posXRelAbsJSE.RestoreFromJSON(jc);
            posYRelAbsJSE.RestoreFromJSON(jc);
            posZRelAbsJSE.RestoreFromJSON(jc);
            rotXRelAbsJSE.RestoreFromJSON(jc);
            rotYRelAbsJSE.RestoreFromJSON(jc);
            rotZRelAbsJSE.RestoreFromJSON(jc);

            positionXJSF.RestoreFromJSON(jc);
            positionYJSF.RestoreFromJSON(jc);
            positionZJSF.RestoreFromJSON(jc);
            rotationXJSF.RestoreFromJSON(jc);
            rotationYJSF.RestoreFromJSON(jc);
            rotationZJSF.RestoreFromJSON(jc);

            relativeAtomNameJSME.RestoreFromJSON(jc);
        }

        public void StoreJSON(JSONClass jc)
        {
            posXRelAbsJSE.StoreJSON(jc);
            posYRelAbsJSE.StoreJSON(jc);
            posZRelAbsJSE.StoreJSON(jc);
            rotXRelAbsJSE.StoreJSON(jc);
            rotYRelAbsJSE.StoreJSON(jc);
            rotZRelAbsJSE.StoreJSON(jc);

            positionXJSF.StoreJSON(jc);
            positionYJSF.StoreJSON(jc);
            positionZJSF.StoreJSON(jc);
            rotationXJSF.StoreJSON(jc);
            rotationYJSF.StoreJSON(jc);
            rotationZJSF.StoreJSON(jc);

            relativeAtomNameJSME.StoreJSON(jc);
        }

        public void Init(JSONStorableEnumStringChooser.SetEnumCallback absRelCallback, JSONStorableMultiEnumStringChooser.SetEnumCallback topEnumCallback, JSONStorableMultiEnumStringChooser.SetMainValCallback mainValCallback, bool createMarker = false)
        {
            posXRelAbsJSE = new JSONStorableEnumStringChooser("posXRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.rel, "", absRelCallback);
            posYRelAbsJSE = new JSONStorableEnumStringChooser("posYRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.abs, "", absRelCallback);
            posZRelAbsJSE = new JSONStorableEnumStringChooser("posZRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.rel, "", absRelCallback);

            positionZJSF.valNoCallback = 1.5f;


            rotXRelAbsJSE = new JSONStorableEnumStringChooser("rotXRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.abs, "", absRelCallback);
            rotYRelAbsJSE = new JSONStorableEnumStringChooser("rotYRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.rel, "", absRelCallback);
            rotationYJSF.valNoCallback = 180f;
            rotZRelAbsJSE = new JSONStorableEnumStringChooser("rotZRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.abs, "", absRelCallback);
            if (!Globals.isVREnabled) relativeAtomNameJSME = new JSONStorableMultiEnumStringChooser("relativeAtomName", AtomUtils.GetAtomNames(), null, null, null, mainValCallback, DesktopRelativePositionMode.enumManifestName, topEnumCallback);
            else relativeAtomNameJSME = new JSONStorableMultiEnumStringChooser("relativeAtomName", AtomUtils.GetAtomNames(), null, null, null, mainValCallback, VRRelativePositionMode.enumManifestName, topEnumCallback);


            relativeNodeNameJSSC = new JSONStorableStringChooser("relativeNodeName", GetTargetNodeChoices(), "control", "Relative to Node");

            if (createMarker) CreateMarker();

        }
        public void InitSettingsCallback(JSONStorableFloat.SetFloatCallback callback, JSONStorableMultiEnumStringChooser.SetEnumCallback topEnumCallback)
        {
            relativeAtomNameJSME = new JSONStorableMultiEnumStringChooser("relativeAtomName", null, null, null, null, null, VRRelativePositionMode.enumManifestName, topEnumCallback);

            positionXJSF.setCallbackFunction = callback;
            positionYJSF.setCallbackFunction = callback;
            positionZJSF.setCallbackFunction = callback;
            rotationXJSF.setCallbackFunction = callback;
            rotationYJSF.setCallbackFunction = callback;
            rotationZJSF.setCallbackFunction = callback;
        }

        public void InitNoCallback()
        {
            if (posXRelAbsJSE == null) posXRelAbsJSE = new JSONStorableEnumStringChooser("posXRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.rel, "");
            if (posYRelAbsJSE == null) posYRelAbsJSE = new JSONStorableEnumStringChooser("posYRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.abs, "");
            if (posZRelAbsJSE == null) posZRelAbsJSE = new JSONStorableEnumStringChooser("posZRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.rel, "");
            positionZJSF.valNoCallback = 1.5f;


            if (rotXRelAbsJSE == null) rotXRelAbsJSE = new JSONStorableEnumStringChooser("rotXRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.abs, "");
            if (rotYRelAbsJSE == null) rotYRelAbsJSE = new JSONStorableEnumStringChooser("rotYRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.rel, "");
            rotationYJSF.valNoCallback = 180f;
            if (rotZRelAbsJSE == null) rotZRelAbsJSE = new JSONStorableEnumStringChooser("rotZRelAbs", AbsoluteRelative.enumManifestName, AbsoluteRelative.abs, "");

            if (relativeAtomNameJSME == null)
            {
                if (!Globals.isVREnabled) relativeAtomNameJSME = new JSONStorableMultiEnumStringChooser("relativeAtomName", AtomUtils.GetAtomNames(), null, null, null, DesktopRelativePositionMode.enumManifestName);
                else relativeAtomNameJSME = new JSONStorableMultiEnumStringChooser("relativeAtomName", AtomUtils.GetAtomNames(), null, null, null, VRRelativePositionMode.enumManifestName);
            }

            if (relativeNodeNameJSSC == null) relativeNodeNameJSSC = new JSONStorableStringChooser("relativeNodeName", GetTargetNodeChoices(), "control", "Relative to Node");
        }

        public void AtomNameUpdated(string oldName, string newName)
        {
            if (relativeAtomNameJSME.valType == JSONStorableMultiEnumStringChooser.mainValFlag && relativeAtomNameJSME.mainVal == oldName)
            {
                RefreshRelativeAtomChoices();
                relativeAtomNameJSME.mainVal = newName;
            }
        }

        public void OnAtomRemoved(Atom atom)
        {
            if (relativeAtomNameJSME.valType == JSONStorableMultiEnumStringChooser.mainValFlag && relativeAtomNameJSME.mainVal == atom.name)
            {
                RefreshRelativeAtomChoices();
                relativeAtomNameJSME.val = relativeAtomNameJSME.choices[0];
            }
        }

        public void RefreshRelativeAtomChoices()
        {
            var atomNames = AtomUtils.GetAtomNames();
            relativeAtomNameJSME.SetMainChoices(atomNames);
            if (relativeAtomNameJSME.popup != null)
            {
                if (atomNames.Count > 10) relativeAtomNameJSME.popup.popupPanelHeight = 250f;
                else relativeAtomNameJSME.popup.popupPanelHeight = (atomNames.Count + 1) * 25f;
            }
        }

        public void RefreshRelativeNodeChoices()
        {
            var nodeNames = GetTargetNodeChoices();
            relativeNodeNameJSSC.choices = nodeNames;
            if (relativeNodeNameJSSC.popup != null)
            {
                if (nodeNames.Count > 10) relativeNodeNameJSSC.popup.popupPanelHeight = 250f;
                else relativeNodeNameJSSC.popup.popupPanelHeight = (nodeNames.Count + 1) * 25f;
            }
        }

        private Transform relativeToTransform
        {
            get
            {
                if (relativeAtomNameJSME.valType == JSONStorableMultiEnumStringChooser.mainValFlag)
                {
                    Atom atom = SuperController.singleton.GetAtomByUid(relativeAtomNameJSME.mainVal);
                    if (atom != null)
                    {
                        if (atom.type != "Person")
                        {
                            FreeControllerV3 nodeFCV3 = atom.freeControllers.First(fc => fc.name == "control");
                            return nodeFCV3.transform;
                        }
                        else if (relativeNodeNameJSSC.val == "Lips" || relativeNodeNameJSSC.val == "Mouth" || relativeNodeNameJSSC.val == "Labia" || relativeNodeNameJSSC.val == "Vagina")
                        {
                            string targetNode = relativeNodeNameJSSC.val;
                            if (relativeNodeNameJSSC.val == "Lips") targetNode = "LipTrigger";
                            else if (relativeNodeNameJSSC.val == "Mouth") targetNode = "MouthTrigger";
                            else if (relativeNodeNameJSSC.val == "Labia") targetNode = "LabiaTrigger";
                            else if (relativeNodeNameJSSC.val == "Vagina") targetNode = "VaginaTrigger";
                            Rigidbody nodeRB = atom.rigidbodies.First(rb => rb.name == targetNode);
                            if (nodeRB != null) return nodeRB.transform;
                        }
                        else if (relativeNodeNameJSSC.val.Contains("control") || relativeNodeNameJSSC.val.Contains("Control"))
                        {
                            FreeControllerV3 nodeFCV3 = atom.freeControllers.First(fc => fc.name == relativeNodeNameJSSC.val);
                            return nodeFCV3.transform;
                        }
                        else
                        {
                            Rigidbody nodeRB = atom.rigidbodies.First(rb => rb.name == relativeNodeNameJSSC.val);
                            return nodeRB.transform;
                        }
                    }
                }
                else
                {
                    if (Globals.isVREnabled)
                    {
                        if (relativeAtomNameJSME.valTopEnum == VRRelativePositionMode.vrHead) return SuperController.singleton.lookCamera.transform;
                        else if (relativeAtomNameJSME.valTopEnum == VRRelativePositionMode.vrLeftHand) return SuperController.singleton.leftControllerCamera.transform;
                        else if (relativeAtomNameJSME.valTopEnum == VRRelativePositionMode.vrRightHand) return SuperController.singleton.rightControllerCamera.transform;
                    }
                    else return SuperController.singleton.lookCamera.transform;

                }
                return null;
            }
        }
        public override Vector3 GetPosition()
        {
            Vector3 absPosition = base.GetPosition();
            if (!isRelativePosition) return absPosition;

            Vector3 offsetPosition = relativeToTransform.localToWorldMatrix * absPosition;

            Vector3 relativePosition = relativeToTransform.position + offsetPosition;

            if (posXRelAbsJSE.val == AbsoluteRelative.abs) relativePosition.x = absPosition.x;
            if (posYRelAbsJSE.val == AbsoluteRelative.abs) relativePosition.y = absPosition.y;
            if (posZRelAbsJSE.val == AbsoluteRelative.abs) relativePosition.z = absPosition.z;

            return relativePosition;
        }

        public override Quaternion GetRotation()
        {
            Quaternion absRotation = base.GetRotation();
            if (!isRelativeRotation) return absRotation;

            Quaternion relativeRotation = absRotation * relativeToTransform.rotation;

            if (rotXRelAbsJSE.val == AbsoluteRelative.abs) relativeRotation.x = absRotation.x;
            if (rotYRelAbsJSE.val == AbsoluteRelative.abs) relativeRotation.y = absRotation.y;
            if (rotZRelAbsJSE.val == AbsoluteRelative.abs) relativeRotation.z = absRotation.z;

            return relativeRotation;
        }

        protected override void UpdateInternalPosRot()
        {
            //Do nothing
        }

        protected override void UpdateTargetAtomPosRot(float val)
        {
            if (guideAtom != null) guideAtom.transform.position = GetPosition();
        }

        public void SetGuideAtomVisible(bool visible)
        {
            
            guideAtomVisible = visible;
        }

        private void CreateMarker()
        {
            var shader = Shader.Find("Hidden/Internal-Colored");

            if (shader != null)
            {
                var markerGO = new GameObject();

                float size = 0.1f;
                float offset = size / 2f;
                float zoffset = 0f;

                CreateQuad(markerGO, new Vector3(size, size, size), new Vector3(0f, 0f, offset + zoffset), new Vector3(-180f, 0f, 0f), shader, Color.blue);

                CreateSphere(markerGO, new Vector3(size * 0.6f, size * 0.6f, size * 0.6f), new Vector3(0f, 0f, offset), shader, new Color(0f, 0f, 0.6f));

                CreateQuad(markerGO, new Vector3(size, size, size), new Vector3(0f, 0f, -offset + zoffset), new Vector3(0f, 0f, 0f), shader, Color.blue);

                CreateQuad(markerGO, new Vector3(size, size, size), new Vector3(offset, 0f, 0f + zoffset), new Vector3(0f, -90f, 0f), shader, Color.red);
                CreateSphere(markerGO, new Vector3(size * 0.6f, size * 0.6f, size * 0.6f), new Vector3(offset, 0f, 0f), shader, new Color(0.6f, 0f, 0f));

                CreateQuad(markerGO, new Vector3(size, size, size), new Vector3(-offset, 0f, 0f + zoffset), new Vector3(0f, 90f, 0f), shader, Color.red);

                CreateQuad(markerGO, new Vector3(size, size, size), new Vector3(0f, offset, 0f + zoffset), new Vector3(90f, 0f, 0f), shader, Color.green);
                CreateSphere(markerGO, new Vector3(size * 0.6f, size * 0.6f, size * 0.6f), new Vector3(0f, offset, 0f), shader, new Color(0f, 0.6f, 0f));

                CreateQuad(markerGO, new Vector3(size, size, size), new Vector3(0f, -offset, 0f + zoffset), new Vector3(-90f, 0f, 0f), shader, Color.green);

                guideAtom = markerGO;
            }
        }

        private void CreateQuad(GameObject parentGO, Vector3 scale, Vector3 positionOffset, Vector3 rotationOffset, Shader shader, Color color)
        {
            var panelGO = GameObject.CreatePrimitive(PrimitiveType.Quad);
            panelGO.transform.localScale = scale;
            panelGO.transform.Translate(positionOffset);
            panelGO.transform.Rotate(rotationOffset);
            GameObject.Destroy(panelGO.transform.GetComponent<MeshCollider>());
            var renderer = panelGO.GetComponent<Renderer>();
            renderer.material.shader = shader;
            renderer.material.SetColor("_Color", color);
            panelGO.transform.parent = parentGO.transform;
        }

        private void CreateSphere(GameObject parentGO, Vector3 scale, Vector3 positionOffset, Shader shader, Color color)
        {
            var sphereGO = GameObject.CreatePrimitive(PrimitiveType.Sphere);
            sphereGO.transform.localScale = scale;
            sphereGO.transform.Translate(positionOffset);
            GameObject.Destroy(sphereGO.transform.GetComponent<SphereCollider>());
            var renderer = sphereGO.GetComponent<Renderer>();
            renderer.material.shader = shader;
            renderer.material.SetColor("_Color", color);
            sphereGO.transform.parent = parentGO.transform;
            renderer.enabled = true;
        }

        void Update()
        {
            if (guideAtom != null)
            {
                guideAtom.transform.position = GetPosition();
                guideAtom.transform.rotation = GetRotation();

                if (BrowserAssist.mainBrowserUI.isVisible && guideAtomVisible) guideAtom.SetActive(true);
                else guideAtom.SetActive(false);
            }
            
        }

        void OnDestroy()
        {
            GameObject.Destroy(guideAtom);
           
        }
    }

 }
